#include <stdio.h>
#include <ctype.h>

#define g_dHydroFactor 1
#define  g_uHydrophobicRunLength 1

static double PAFFacs[26] =
        {
        1.13,           // A
	1,		//b
        1.13,           // C
        0.96,           // D
        1.31,           // E
        1.20,           // F
        0.61,           // G
        1.00,           // H
        1.32,           // I
	1,		// j
        0.96,           // K
        1.21,           // L
        1.29,           // M
        0.62,           // N
	1,		// o
        0.74,           // P
        1.07,           // Q
        0.72,           // R
        0.76,           // S
        0.89,           // T
	1,		// u
        1.25,           // V
        1.23,           // W
	1,		// x
        1.00,           // Y
	1		// z
        };

static int Hydrophobic[26] =
        {
        1,           // A
        0,          // b
        1,           // C
        0,          // D
        0,          // E
        1,           // F
        0,          // G
        1,           // H
        1,           // I
        0,          // j
        0,          // K
        1,           // L
        1,           // M
        0,          // N
        0,          // o
        0,          // P
        0,          // Q
        0,          // R
        0,          // S
        1,           // T
        0,          // u
        1,           // V
        1,           // W
        0,          // x
        1,           // Y
        0           // z
        };  

// Apply hydrophobicity heuristic to a profile
// Usman: modified to decrease cost for hydrophilic run
void Hydro(char *prof,float* hyd, unsigned uLength){
	unsigned uRunLength = 0; unsigned uColIndex = 0; unsigned n=0;
        int bHydro = 0;
	if (0 == g_uHydrophobicRunLength)
		return;
        for (uColIndex = 0; uColIndex < uLength; ++uColIndex){
		bHydro = Hydrophobic[tolower(prof[uColIndex])-'a'];
		if (bHydro){
//Usman
//		if (!bHydro){
			++uRunLength;
			if (uRunLength > g_uHydrophobicRunLength){
				 hyd[uColIndex]*= g_dHydroFactor;
			}
			else if (uRunLength == g_uHydrophobicRunLength)	{
				for (n = uColIndex - (g_uHydrophobicRunLength - 1);n <= uColIndex; ++n){
					hyd[n]*=g_dHydroFactor;
				}
			}
		}
		else
			uRunLength = 0;
	}
}

