#include "pfgoto.h"


/* score matrix for the initial alignement: gonnet 116.5 matrix see:
   Science . Vol 256 . 5June1992 . 1443 ff & J.Mol.Biol.(1995) 249, 816 ff */

score_m gonnet_init =
{

  "gonnet_init",
  
  116.5,                       /* PAM distance */ 

  LN10/10,                     /* Beta = (ln10)/10  */

  "CSTPAGNDEQHRKMILVFYW",      /* amino acid order */ 

  {
   11.5,
    0.1,  2.2,
   -0.5,  1.5,  2.5,
   -3.1,  0.4,  0.1,  7.6,
    0.5,  1.1,  0.6,  0.3,  2.4,
   -2.0,  0.4, -1.1, -1.6,  0.5,  6.6,
   -1.8,  0.9,  0.5, -0.9, -0.3,  0.4,  3.8,
   -3.2,  0.5,  0.0, -0.7, -0.3,  0.1,  2.2,  4.7,
   -3.0,  0.2, -0.1, -0.5,  0.0, -0.8,  0.9,  2.7,  3.6,
   -2.4,  0.2,  0.0, -0.2, -0.2, -1.0,  0.7,  0.9,  1.7,  2.7,
   -1.3, -0.2, -0.3, -1.1, -0.8, -1.4,  1.2,  0.4,  0.4,  1.2,  6.0,
   -2.2, -0.2, -0.2, -0.9, -0.6, -1.0,  0.3, -0.3,  0.4,  1.5,  0.6,  4.7,
   -2.8,  0.1,  0.1, -0.6, -0.4, -1.1,  0.8,  0.5,  1.2,  1.5,  0.6,  2.7,  3.2,
   -0.9, -1.4, -0.6, -2.4, -0.7, -3.5, -2.2, -3.0, -2.0, -1.0, -1.3, -1.7, -1.4,  4.3,
   -1.1, -1.8, -0.6, -2.6, -0.8, -4.5, -2.8, -3.8, -2.7, -1.9, -2.2, -2.4, -2.1,  2.5,  4.0,
   -1.5, -2.1, -1.3, -2.3, -1.2, -4.4, -3.0, -4.0, -2.8, -1.6, -1.9, -2.2, -2.1,  2.8,  2.8,  4.0,
    0.0, -1.0,  0.0, -1.8,  0.1, -3.3, -2.2, -2.9, -1.9, -1.5, -2.0, -2.0, -1.7,  1.6,  3.1,  1.8,  3.4,
   -0.8, -2.8, -2.2, -3.8, -2.3, -5.2, -3.1, -4.5, -3.9, -2.6, -0.1, -3.2, -3.3,  1.6,  1.0,  2.0,  0.1,  7.0,
   -0.5, -1.9, -1.9, -3.1, -2.2, -4.0, -1.4, -2.8, -2.7, -1.7,  2.2, -1.8, -2.1, -0.2, -0.7,  0.0, -1.1,  5.1, 7.8,
   -1.0, -3.3, -3.5, -5.0, -3.6, -4.0, -3.6, -5.2, -4.3, -2.7, -0.8, -1.6, -3.5, -1.0, -1.8, -0.7, -2.6,  3.6, 4.1, 14.2 },

  {6.00, 0.80},   /* gap open und extend penalties for an all positive matrix see: J.Mol.Biol.(1995) 249, 816 ff */

  {14.0, 0.20},  /* gap open und extend penalties for a +/- matrix see: J.Mol.Biol.(1995) 249, 816 ff */
/*
    {
    224, 
    15, 53, 
    2, 32, 68, 
    -44, 5, -12, 160, 
    23, 23, 15, 1, 58, 
    -30, 5, -26, -36, 10, 140, 
    -33, 22, 10, -25, -8, 4, 89, 
    -67, -7, -63, 18, -12, 4, -13, 111, 
    -63, 1, -7, -12, -7, -17, 15, 59, 85, 
    -53, 1, -4, -6, -9, -29, 12, 18, 40, 75, 
    -29, -4, -12, -23, -23, -32, 21, 4, -1, 27, 137, 
    -43, -10, -14, -20, -22, -32, 2, -29, -8, 34, 19, 113, 
    -56, -3, -4, -12, -14, -27, 13, 6, 25, 34, 6, 68, 75, 
    -6, -35, -9, -54, -17, -75, -45, -65, -47, -21, -42, -31, -30, 103, 
    1, -43, -8, -60, -14, -95, -62, -84, -63, -47, -50, -55, -53, 47, 86, 
    -41, -47, -25, -48, -27, -91, -63, -88, -60, -36, -37, -48, -48, 62, 53, 88, 
    18, -28, 0, -42, 5, -68, -51, -63, -47, -37, -44, -49, -44, 31, 69, 36, 74, 
    -50, -43, -41, -67, -44, -93, -64, -104, -83, -56, 4, -65, -74, 30, 12, 36, -3, 144, 
    -6, -31, -40, -83, -45, -79, -29, -73, -51, -48, 48, -39, -49, -20, -24, -4, -32, 104, 162, 
    -93, -62, -87, -76, -74, -80, -79, -105, -108, -92, -13, -58, -71, -46, -27, -11, -61, 63, 81, 289 },
*/
//  {0.0, 0.0},   /* gap open und extend penalties for an all positive matrix see: J.Mol.Biol.(1995) 249, 816 ff */

//  {300.0, 11.0},  /* gap open und extend penalties for a +/- matrix see: J.Mol.Biol.(1995) 249, 816 ff */

  0.0,
};


/* blosum matrices, the blosum matrix series is taken from the dbclustal header matrices.h
   see also: Proc.Natl.Acad.Sci.USA; Nov.1992; Vol 89, 10915 ff */
/* blosum_30 */

static score_m blosum_30 =
{

  "blosum_30",

  30,  /* matrix derived from a data base of blocks in which sequence segments that are
			      identical at >= 30% of aligned residues are clustered */ 

//  LN2/2,                         /* Beta = (ln2)/2  */
  1,                         /* Beta = (ln2)/2  */
  
  "ABCDEFGHIKLMNPQRSTVWXYZ",     /* amino acid order */ 

  
  {
     4,
     0,  5,
    -3, -2, 17,
     0,  5, -3,  9,
     0,  0,  1,  1,  6,
    -2, -3, -3, -5, -4, 10,
     0,  0, -4, -1, -2, -3,  8,
    -2, -2, -5, -2,  0, -3, -3, 14,
     0, -2, -2, -4, -3,  0, -1, -2,  6,
     0,  0, -3,  0,  2, -1, -1, -2, -2,  4,
    -1, -1,  0, -1, -1,  2, -2, -1,  2, -2,  4,
     1, -2, -2, -3, -1, -2, -2,  2,  1,  2,  2,  6,
     0,  4, -1,  1, -1, -1,  0, -1,  0,  0, -2,  0,  8,
    -1, -2, -3, -1,  1, -4, -1,  1, -3,  1, -3, -4, -3, 11,
     1, -1, -2, -1,  2, -3, -2,  0, -2,  0, -2, -1, -1,  0,  8,
    -1, -2, -2, -1, -1, -1, -2, -1, -3,  1, -2,  0, -2, -1,  3,  8,
     1,  0, -2,  0,  0, -1,  0, -1, -1,  0, -2, -2,  0, -1, -1, -1,  4,
     1,  0, -2, -1, -2, -2, -2, -2,  0, -1,  0,  0,  1,  0,  0, -3,  2,  5,
     1, -2, -2, -2, -3,  1, -3, -3,  4, -2,  1,  0, -2, -4, -3, -1, -1,  1,  5,
    -5, -5, -2, -4, -1,  1,  1, -5, -3, -2, -2, -3, -7, -3, -1,  0, -3, -5, -3, 20,
     0, -1, -2, -1, -1, -1, -1, -1,  0,  0,  0,  0,  0, -1,  0, -1,  0,  0,  0, -2, -1,
    -4, -3, -6, -1, -2,  3, -3,  0, -1, -1,  3, -1, -4, -2, -1,  0, -2, -1,  1,  5, -1,  9,
     0,  0,  0,  0,  5, -4, -2,  0, -3,  1, -1, -1, -1,  0,  4,  0, -1, -1, -3, -1,  0, -2,  4 },

  {9.00, 1.00},   /* gap open und extend penalties for an all positive matrix see: J.Mol.Biol.(1995) 249, 816 ff */

  {10.0, 1.50},   /* gap open und extend penalties for a +/- matrix see: J.Mol.Biol.(1995) 249, 816 ff */

  0.0,
};


static score_m blosum_50 =
{

  "blosum_50",
  
   50,                             /* matrix derived from a data base of blocks in which sequence segments that are
				    identical at >= 50% of aligned residues are clustered */ 

//  LN2/2,                            /* Beta = (ln2)/2  */
  1,                            /* Beta = (ln2)/2  */

  "ABCDEFGHIKLMNPQRSTVWXYZ",      /* amino acid order */ 

  {
     5,
    -2,  5,
    -1, -3, 13,
    -2,  5, -4,  8,
    -1,  1, -3,  2,  6,
    -3, -4, -2, -5, -3,  8,
     0, -1, -3, -1, -3, -4,  8,
    -2,  0, -3, -1,  0, -1, -2, 10,
    -1, -4, -2, -4, -4,  0, -4, -4,  5,
    -1,  0, -3, -1,  1, -4, -2,  0, -3,  6,
    -2, -4, -2, -4, -3,  1, -4, -3,  2, -3,  5,
    -1, -3, -2, -4, -2,  0, -3, -1,  2, -2,  3,  7,
    -1,  4, -2,  2,  0, -4,  0,  1, -3,  0, -4, -2,  7,
    -1, -2, -4, -1, -1, -4, -2, -2, -3, -1, -4, -3, -2, 10,
    -1,  0, -3,  0,  2, -4, -2,  1, -3,  2, -2,  0,  0, -1,  7,
    -2, -1, -4, -2,  0, -3, -3,  0, -4,  3, -3, -2, -1, -3,  1,  7,
     1,  0, -1,  0, -1, -3,  0, -1, -3,  0, -3, -2,  1, -1,  0, -1,  5,
     0,  0, -1, -1, -1, -2, -2, -2, -1, -1, -1, -1,  0, -1, -1, -1,  2,  5,
     0, -4, -1, -4, -3, -1, -4, -4,  4, -3,  1,  1, -3, -3, -3, -3, -2,  0,  5,
    -3, -5, -5, -5, -3,  1, -3, -3, -3, -3, -2, -1, -4, -4, -1, -3, -4, -3, -3, 15,
    -1, -1, -2, -1, -1, -2, -2, -1, -1, -1, -1, -1, -1, -2, -1, -1, -1,  0, -1, -3, -1,
    -2, -3, -3, -3, -2,  4, -3,  2, -1, -2, -1,  0, -2, -3, -1, -1, -2, -2, -1,  2, -1,  8,
    -1,  2, -3,  1,  5, -4, -2,  0, -3,  1, -3, -1,  0, -1,  4,  0,  0, -1, -3, -2, -1, -2,  5 },

  

  {9.50, 0.60},   /* gap open und extend penalties for an all positive matrix see: J.Mol.Biol.(1995) 249, 816 ff */

  {9.50, 1.20},   /* gap open und extend penalties for a +/- matrix see: J.Mol.Biol.(1995) 249, 816 ff */

  0.0,
};


static score_m blosum_62 =
{
  "blosum_62",
  
  62,                             /* matrix derived from a data base of blocks in which sequence segments that are
				    identical at >= 62% of aligned residues are clustered */ 
//  LN2/2,                          /* Beta = (ln2)/2  */
  1,                          /* Beta = (ln2)/2  */

//  "ABCDEFGHIKLMNPQRSTVWXYZ",
/*
  {
     4,
    -2,  4,
     0, -3,  9,
    -2,  4, -3,  6,
    -1,  1, -4,  2,  5,
    -2, -3, -2, -3, -3,  6,
     0, -1, -3, -1, -2, -3,  6,
    -2,  0, -3, -1,  0, -1, -2,  8,
    -1, -3, -1, -3, -3,  0, -4, -3,  4,
    -1,  0, -3, -1,  1, -3, -2, -1, -3,  5,
    -1, -4, -1, -4, -3,  0, -4, -3,  2, -2,  4,
    -1, -3, -1, -3, -2,  0, -3, -2,  1, -1,  2,  5,
    -2,  3, -3,  1,  0, -3,  0,  1, -3,  0, -3, -2,  6,
    -1, -2, -3, -1, -1, -4, -2, -2, -3, -1, -3, -2, -2,  7,
    -1,  0, -3,  0,  2, -3, -2,  0, -3,  1, -2,  0,  0, -1,  5,
    -1, -1, -3, -2,  0, -3, -2,  0, -3,  2, -2, -1,  0, -2,  1,  5,
     1,  0, -1,  0,  0, -2,  0, -1, -2,  0, -2, -1,  1, -1,  0, -1,  4,
     0, -1, -1, -1, -1, -2, -2, -2, -1, -1, -1, -1,  0, -1, -1, -1,  1,  5,
     0, -3, -1, -3, -2, -1, -3, -3,  3, -2,  1,  1, -3, -2, -2, -3, -2,  0,  4,
    -3, -4, -2, -4, -3,  1, -2, -2, -3, -3, -2, -1, -4, -4, -2, -3, -3, -2, -3, 11,
     0, -1, -2, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -2, -1, -1,  0,  0, -1, -2, -1,
    -2, -3, -2, -3, -2,  3, -3,  2, -1, -2, -1, -1, -2, -3, -1, -2, -2, -2, -1,  2, -1,  7,
    -1,  1, -3,  1,  4, -3, -2,  0, -3,  1, -3, -1,  0, -1,  3,  0,  0, -1, -2, -3, -1, -2,  4 },
*/

  "ACDEFGHIKLMNPQRSTVWY",

//BLOSUM62 with scaling=5 (instead of default 2)
   {
     10.00, 
     -1.00,  21.00, 
     -4.00,  -9.00,  14.00, 
     -2.00,  -9.00,  4.00,  12.00, 
     -6.00,  -6.00,  -9.00,  -8.00,  15.00, 
     0.00,  -6.00,  -3.00,  -5.00,  -8.00,  14.00, 
     -4.00,  -7.00,  -3.00,  0.00,  -3.00,  -5.00,  19.00, 
     -3.00,  -3.00,  -8.00,  -8.00,  0.00,  -9.00,  -8.00,  10.00, 
     -2.00,  -8.00,  -2.00,  2.00,  -8.00,  -4.00,  -2.00,  -7.00,  11.00, 
     -4.00,  -3.00,  -9.00,  -7.00,  1.00,  -9.00,  -7.00,  4.00,  -6.00,  10.00, 
     -2.00,  -4.00,  -8.00,  -5.00,  0.00,  -7.00,  -4.00,  3.00,  -3.00,  5.00,  13.00, 
     -4.00,  -7.00,  3.00,  -1.00,  -7.00,  -1.00,  1.00,  -8.00,  0.00,  -8.00,  -5.00,  14.00, 
     -2.00,  -7.00,  -4.00,  -3.00,  -9.00,  -5.00,  -5.00,  -7.00,  -3.00,  -7.00,  -6.00,  -5.00,  18.00, 
     -2.00,  -7.00,  -1.00,  5.00,  -8.00,  -4.00,  1.00,  -7.00,  3.00,  -5.00,  -1.00,  0.00,  -3.00,  13.00, 
     -4.00,  -8.00,  -4.00,  0.00,  -7.00,  -6.00,  -1.00,  -7.00,  5.00,  -5.00,  -3.00,  -1.00,  -5.00,  2.00,  14.00, 
     3.00,  -2.00,  -1.00,  0.00,  -6.00,  -1.00,  -2.00,  -6.00,  -1.00,  -6.00,  -4.00,  2.00,  -2.00,  0.00,  -2.00,  10.00, 
     0.00,  -2.00,  -3.00,  -2.00,  -5.00,  -4.00,  -4.00,  -2.00,  -2.00,  -3.00,  -2.00,  0.00,  -3.00,  -2.00,  -3.00,  3.00,  11.00, 
     0.00,  -2.00,  -8.00,  -6.00,  -2.00,  -8.00,  -8.00,  6.00,  -6.00,  2.00,  2.00,  -7.00,  -6.00,  -5.00,  -6.00,  -4.00,  0.00,  9.00, 
     -6.00,  -6.00,  -11.00,  -7.00,  2.00,  -6.00,  -6.00,  -6.00,  -7.00,  -4.00,  -4.00,  -9.00,  -9.00,  -5.00,  -7.00,  -7.00,  -6.00,  -7.00,  26.00, 
     -4.00,  -6.00,  -8.00,  -5.00,  7.00,  -8.00,  4.00,  -3.00,  -5.00,  -3.00,  -2.00,  -5.00,  -7.00,  -4.00,  -4.00,  -4.00,  -4.00,  -3.00,  5.00,  16.00 },

//BLOSUM62 with scaling=4 (instead of default 2)
/*
     {
     8.00, 
     -1.00,  17.00, 
     -4.00,  -7.00,  12.00, 
     -2.00,  -7.00,  3.00,  10.00, 
     -4.00,  -5.00,  -7.00,  -6.00,  12.00, 
     0.00,  -5.00,  -3.00,  -4.00,  -6.00,  11.00, 
     -3.00,  -6.00,  -2.00,  0.00,  -2.00,  -4.00,  15.00, 
     -3.00,  -2.00,  -6.00,  -6.00,  0.00,  -7.00,  -6.00,  8.00, 
     -1.00,  -6.00,  -1.00,  2.00,  -6.00,  -3.00,  -1.00,  -5.00,  9.00, 
     -3.00,  -3.00,  -7.00,  -6.00,  1.00,  -7.00,  -6.00,  3.00,  -5.00,  8.00, 
     -2.00,  -3.00,  -6.00,  -4.00,  0.00,  -5.00,  -3.00,  2.00,  -3.00,  4.00,  11.00, 
     -3.00,  -5.00,  3.00,  -1.00,  -6.00,  -1.00,  1.00,  -6.00,  0.00,  -7.00,  -4.00,  11.00, 
     -2.00,  -6.00,  -3.00,  -2.00,  -7.00,  -4.00,  -4.00,  -6.00,  -2.00,  -6.00,  -5.00,  -4.00,  15.00, 
     -2.00,  -6.00,  -1.00,  4.00,  -6.00,  -4.00,  1.00,  -6.00,  3.00,  -4.00,  -1.00,  0.00,  -3.00,  11.00, 
     -3.00,  -7.00,  -3.00,  0.00,  -6.00,  -5.00,  0.00,  -6.00,  4.00,  -4.00,  -3.00,  -1.00,  -4.00,  2.00,  11.00, 
     2.00,  -2.00,  -1.00,  0.00,  -5.00,  -1.00,  -2.00,  -5.00,  0.00,  -5.00,  -3.00,  1.00,  -2.00,  0.00,  -2.00,  8.00, 
     0.00,  -2.00,  -2.00,  -2.00,  -4.00,  -3.00,  -3.00,  -1.00,  -1.00,  -2.00,  -1.00,  0.00,  -2.00,  -1.00,  -2.00,  3.00,  9.00, 
     0.00,  -2.00,  -6.00,  -5.00,  -2.00,  -6.00,  -6.00,  5.00,  -5.00,  2.00,  1.00,  -6.00,  -5.00,  -4.00,  -5.00,  -3.00,  0.00,  8.00, 
     -5.00,  -5.00,  -8.00,  -6.00,  2.00,  -5.00,  -5.00,  -5.00,  -6.00,  -3.00,  -3.00,  -7.00,  -7.00,  -4.00,  -5.00,  -6.00,  -5.00,  -6.00,  21.00, 
     -4.00,  -5.00,  -6.00,  -4.00,  6.00,  -6.00,  3.00,  -3.00,  -4.00,  -2.00,  -2.00,  -4.00,  -6.00,  -3.00,  -3.00,  -3.00,  -3.00,  -2.00,  4.00,  13.0},
*/

//BLOSUM62 with scaling=3 (instead of default 2)
/*
    {
     6.00, 
     -1.00,  13.00, 
     -3.00,  -5.00,  9.00, 
     -1.00,  -5.00,  2.00,  7.00, 
     -3.00,  -4.00,  -5.00,  -5.00,  9.00, 
     0.00,  -4.00,  -2.00,  -3.00,  -5.00,  8.00, 
     -2.00,  -4.00,  -2.00,  0.00,  -2.00,  -3.00,  11.00, 
     -2.00,  -2.00,  -5.00,  -5.00,  0.00,  -6.00,  -5.00,  6.00, 
     -1.00,  -5.00,  -1.00,  1.00,  -5.00,  -2.00,  -1.00,  -4.00,  7.00, 
     -2.00,  -2.00,  -5.00,  -4.00,  1.00,  -5.00,  -4.00,  2.00,  -4.00,  6.00, 
     -1.00,  -2.00,  -5.00,  -3.00,  0.00,  -4.00,  -2.00,  2.00,  -2.00,  3.00,  8.00, 
     -2.00,  -4.00,  2.00,  0.00,  -4.00,  -1.00,  1.00,  -5.00,  0.00,  -5.00,  -3.00,  8.00, 
     -1.00,  -4.00,  -2.00,  -2.00,  -5.00,  -3.00,  -3.00,  -4.00,  -2.00,  -4.00,  -4.00,  -3.00,  11.00, 
     -1.00,  -4.00,  0.00,  3.00,  -5.00,  -3.00,  1.00,  -4.00,  2.00,  -3.00,  -1.00,  0.00,  -2.00,  8.00, 
     -2.00,  -5.00,  -2.00,  0.00,  -4.00,  -3.00,  0.00,  -4.00,  3.00,  -3.00,  -2.00,  -1.00,  -3.00,  1.00,  8.00, 
     2.00,  -1.00,  0.00,  0.00,  -4.00,  0.00,  -1.00,  -4.00,  0.00,  -4.00,  -2.00,  1.00,  -1.00,  0.00,  -1.00,  6.00, 
     0.00,  -1.00,  -2.00,  -1.00,  -3.00,  -2.00,  -3.00,  -1.00,  -1.00,  -2.00,  -1.00,  0.00,  -2.00,  -1.00,  -2.00,  2.00,  7.00, 
     0.00,  -1.00,  -5.00,  -4.00,  -1.00,  -5.00,  -5.00,  4.00,  -3.00,  1.00,  1.00,  -4.00,  -4.00,  -3.00,  -4.00,  -2.00,  0.00,  6.00, 
     -4.00,  -3.00,  -6.00,  -4.00,  1.00,  -4.00,  -4.00,  -4.00,  -4.00,  -2.00,  -2.00,  -6.00,  -5.00,  -3.00,  -4.00,  -4.00,  -4.00,  -4.00,  16.00, 
     -3.00,  -4.00,  -5.00,  -3.00,  4.00,  -5.00,  3.00,  -2.00,  -3.00,  -2.00,  -1.00,  -3.00,  -4.00,  -2.00,  -3.00,  -3.00,  -2.00,  -2.00,  3.00,  10.00 },
*/

//Blosum62 --- no bits scaling
/*
  {
     1.965, 
     -0.204,  4.291, 
     -0.877,  -1.730,  2.887, 
     -0.432,  -1.806,  0.755,  2.451, 
     -1.105,  -1.188,  -1.742,  -1.596,  3.023, 
     0.080,  -1.250,  -0.657,  -1.055,  -1.554,  2.782, 
     -0.813,  -1.494,  -0.559,  -0.059,  -0.617,  -1.020,  3.756, 
     -0.661,  -0.614,  -1.561,  -1.597,  -0.080,  -1.862,  -1.616,  1.999, 
     -0.367,  -1.518,  -0.351,  0.388,  -1.539,  -0.764,  -0.360,  -1.335,  2.252, 
     -0.732,  -0.639,  -1.803,  -1.423,  0.207,  -1.813,  -1.393,  0.761,  -1.223,  1.925, 
     -0.468,  -0.710,  -1.529,  -0.999,  0.006,  -1.338,  -0.776,  0.563,  -0.677,  0.996,  2.696, 
     -0.765,  -1.330,  0.636,  -0.134,  -1.497,  -0.211,  0.289,  -1.609,  -0.089,  -1.690,  -1.075,  2.827, 
     -0.407,  -1.398,  -0.740,  -0.558,  -1.799,  -1.067,  -1.081,  -1.378,  -0.507,  -1.430,  -1.238,  -1.000,  3.682, 
     -0.402,  -1.451,  -0.157,  0.927,  -1.582,  -0.893,  0.224,  -1.385,  0.636,  -1.067,  -0.210,  0.001,  -0.641,  2.643, 
     -0.707,  -1.695,  -0.803,  -0.058,  -1.393,  -1.152,  -0.125,  -1.495,  1.054,  -1.077,  -0.684,  -0.220,  -1.054,  0.491,  2.737, 
     0.558,  -0.438,  -0.131,  -0.073,  -1.184,  -0.146,  -0.441,  -1.174,  -0.102,  -1.221,  -0.740,  0.300,  -0.405,  -0.051,  -0.382,  1.942, 
     -0.023,  -0.433,  -0.525,  -0.432,  -1.054,  -0.788,  -0.843,  -0.359,  -0.335,  -0.599,  -0.333,  -0.023,  -0.538,  -0.338, -0.561,  0.691,  2.273, 
     -0.095,  -0.404,  -1.571,  -1.221,  -0.424,  -1.569,  -1.559,  1.274,  -1.131,  0.394,  0.344,  -1.438,  -1.174,  -1.099,  -1.251,  -0.823,  -0.028,  1.885, 
     -1.263,  -1.152,  -2.107,  -1.418,  0.459,  -1.246,  -1.171,  -1.290,  -1.478,  -0.816,  -0.712,  -1.848,  -1.827,  -0.973,  -1.340,  -1.376,  -1.214,  -1.417,  5.252, 
     -0.882,  -1.204,  -1.532,  -1.010,  1.470,  -1.520,  0.846,  -0.666,  -0.910,  -0.531,  -0.497,  -1.041,  -1.460,  -0.711,  -0.847,  -0.843,  -0.803,  -0.604,  1.077,  3.297 },
*/

//Blosum62 --- probability matrix scaled by 1000
/*
{
    21.5, 
     1.6,  11.9, 
     2.2,  0.4,  21.3, 
     3.0,  0.4,  4.9,  16.1, 
     1.6,  0.5,  0.8,  0.9,  18.3, 
     5.8,  0.8,  2.5,  1.9,  1.2,  37.8, 
     1.1,  0.2,  1.0,  1.4,  0.8,  1.0,  9.3, 
     3.2,  1.1,  1.2,  1.2,  3.0,  1.4,  0.6,  18.4, 
     3.3,  0.5,  2.4,  4.1,  0.9,  2.5,  1.2,  1.6,  16.1, 
     4.4,  1.6,  1.5,  2.0,  5.4,  2.1,  1.0,  11.4,  2.5,  37.1, 
     1.3,  0.4,  0.5,  0.7,  1.2,  0.7,  0.4,  2.5,  0.9,  4.9,  4.0, 
     1.9,  0.4,  3.7,  2.2,  0.8,  2.9,  1.4,  1.0,  2.4,  1.4,  0.5,  14.1, 
     2.2,  0.4,  1.2,  1.4,  0.5,  1.4,  0.5,  1.0,  1.6,  1.4,  0.4,  0.9,  19.1, 
     1.9,  0.3,  1.6,  3.5,  0.5,  1.4,  1.0,  0.9,  3.1,  1.6,  0.7,  1.5,  0.8,  7.3, 
     2.3,  0.4,  1.6,  2.7,  0.9,  1.7,  1.2,  1.2,  6.2,  2.4,  0.8,  2.0,  1.0,  2.5,  17.8, 
     6.3,  1.0,  2.8,  3.0,  1.2,  3.8,  1.1,  1.7,  3.1,  2.4,  0.9,  3.1,  1.7,  1.9,  2.3,  12.6, 
     3.7,  0.9,  1.9,  2.0,  1.2,  2.2,  0.7,  2.7,  2.3,  3.3,  1.0,  2.2,  1.4,  1.4,  1.8,  4.7,  12.5, 
     5.1,  1.4,  1.3,  1.7,  2.6,  1.8,  0.6,  12.0,  1.9,  9.5,  2.3,  1.2,  1.2,  1.2,  1.6,  2.4,  3.6,  19.6, 
     0.4,  0.1,  0.2,  0.3,  0.8,  0.4,  0.2,  0.4,  0.3,  0.7,  0.2,  0.2,  0.1,  0.2,  0.3,  0.3,  0.3,  0.4,  6.5, 
     1.3,  0.3,  0.6,  0.9,  4.2,  0.8,  1.5,  1.4,  1.0,  2.2,  0.6,  0.7,  0.5,  0.7,  0.9,  1.0,  0.9,  1.5,  0.9,  10.2 },
*/

//  "ABCDEFGHIKLMNPQRSTVWXYZ",
//SDM
/*
{
     2.09, 
     -0.66,  3.83, 
     0.33,  -2.32,  6.99, 
     -0.73,  3.00,  -2.51,  4.02, 
     -0.12,  0.58,  -1.97,  1.20,  2.97, 
     -0.76,  -2.22,  1.13,  -2.19,  -1.61,  3.28, 
     0.27,  -0.29,  -2.11,  -1.20,  -0.41,  -2.67,  4.36, 
     -1.42,  0.34,  -1.50,  -0.01,  -0.62,  -0.22,  -0.40,  5.89, 
     -0.97,  -2.62,  0.13,  -2.77,  -1.81,  0.76,  -2.93,  -1.76,  2.76, 
     -0.38,  0.74,  -2.19,  0.66,  1.11,  -2.41,  -0.71,  0.31,  -1.81,  2.91, 
     -0.39,  -2.40,  -0.31,  -2.65,  -2.11,  1.23,  -1.98,  -0.93,  1.56,  -1.96,  2.43, 
     -0.04,  -2.32,  1.04,  -2.58,  -1.86,  0.80,  -1.86,  -1.04,  0.99,  -1.62,  1.61,  3.75, 
     -0.57,  2.61,  -2.08,  1.78,  -0.16,  -2.25,  0.79,  0.76,  -2.43,  0.83,  -2.10,  -2.01,  3.60, 
     -0.53,  -0.10,  -2.19,  0.72,  -0.26,  -0.91,  -0.04,  -1.44,  -2.00,  -0.19,  -1.56,  -1.09,  -1.10,  5.45, 
     -0.75,  0.34,  -0.83,  0.34,  1.23,  -2.31,  -0.12,  -0.46,  -1.47,  0.92,  -1.49,  -0.13,  0.33,  0.24,  2.60, 
     -0.50,  0.34,  -1.30,  0.13,  0.99,  -1.40,  -0.96,  0.54,  -1.40,  1.42,  -1.19,  -0.63,  0.60,  0.21,  0.13,  2.87, 
     0.34,  0.57,  0.31,  0.71,  0.31,  -1.11,  0.29,  -0.74,  -1.75,  -0.06,  -2.30,  -1.34,  0.40,  -0.29,  1.04,  -0.06,  2.36, 
     0.13,  -0.27,  -0.59,  -0.75,  -0.21,  -0.69,  -0.81,  -0.52,  -0.96,  -0.10,  -0.86,  -1.58,  0.30,  0.93,  0.60,  -0.15,  1.20,  2.04, 
     0.02,  -2.09,  0.34,  -2.02,  -1.84,  0.51,  -1.96,  -0.35,  1.94,  -1.27,  0.81,  0.61,  -2.17,  -1.11,  -1.38,  -1.52,  -1.11,  0.05,  2.05, 
     -0.66,  -2.36,  -0.76,  -1.91,  -2.70,  2.29,  -1.21,  -1.48,  0.25,  -1.94,  -0.14,  0.87,  -2.89,  -5.34,  -0.81,  -0.04,  -1.18,  -0.57,  -1.09,  6.96, 
     -0.14,  -0.39,  -0.60,  -0.60,  -0.38,  -0.48,  -0.68,  -0.44,  -0.56,  -0.37,  -0.47,  -0.39,  -0.44,  -0.53,  -0.23,  -0.24,  -0.26,  -0.13,  -0.33,  -0.74,  -0.39, 
     -1.25,  -0.82,  0.13,  -1.21,  -1.64,  1.96,  -1.62,  -0.12,  0.08,  -1.72,  0.70,  -0.41,  -0.36,  -1.98,  -0.61,  -0.75,  -1.56,  -0.41,  0.21,  2.15,  -0.39,  3.95, 
     -0.36,  0.49,  -1.53,  0.87,  2.30,  -1.88,  -0.30,  -0.56,  -1.68,  1.04,  -1.87,  -1.19,  0.03,  -0.06,  1.76,  0.66,  0.59,  0.10,  -1.66,  -1.97,  -0.39,  -1.25,  2.83 },
*/
  
//HSDM
/*
{
     5.50, 
     -2.10,  10.55, 
     0.45,  -6.78,  19.05, 
     -2.38,  7.86,  -6.98,  11.01, 
     -0.47,  1.14,  -4.70,  2.41,  8.43, 
     -2.42,  -5.58,  1.72,  -5.06,  -4.44,  9.14, 
     0.63,  -1.61,  -5.70,  -3.91,  -1.80,  -7.46,  11.64, 
     -3.01,  0.98,  -5.95,  0.32,  -1.29,  0.25,  -1.24,  15.72, 
     -1.72,  -6.00,  -0.13,  -6.18,  -5.89,  2.30,  -8.58,  -4.44,  6.74, 
     -1.22,  1.58,  -6.65,  1.53,  3.08,  -6.19,  -1.82,  -0.17,  -4.82,  8.23, 
     -1.09,  -6.61,  -0.82,  -7.41,  -5.62,  3.90,  -6.55,  -2.49,  3.86,  -5.91,  6.38, 
     0.16,  -6.43,  3.50,  -7.88,  -3.94,  2.66,  -5.29,  -3.66,  2.94,  -5.47,  4.32,  10.21, 
     -1.77,  6.76,  -6.53,  4.07,  -0.39,  -6.22,  1.16,  1.77,  -5.78,  1.64,  -5.64,  -4.67,  10.00, 
     -1.11,  -1.02,  -6.70,  0.81,  -0.43,  -2.96,  -1.79,  -3.55,  -4.04,  -1.21,  -2.88,  -2.02,  -3.23,  13.32, 
     -2.16,  1.24,  -2.47,  1.10,  3.16,  -5.54,  -0.24,  -2.24,  -3.26,  3.24,  -4.56,  -1.76,  1.42,  1.30,  7.85, 
     -2.24,  -0.07,  -6.29,  -0.33,  2.83,  -4.36,  -3.39,  0.70,  -3.93,  3.89,  -2.83,  -1.43,  0.24,  1.31,  -0.74,  8.59, 
     1.27,  1.98,  1.08,  2.34,  0.42,  -5.03,  0.63,  -2.38,  -4.67,  -0.27,  -6.22,  -3.92,  1.54,  -1.28,  2.59,  -0.50,  6.35, 
     0.60,  -0.23,  -1.89,  -1.36,  -0.61,  -4.00,  -2.24,  -1.14,  -3.03,  -0.37,  -2.40,  -5.18,  1.14,  2.44,  1.08,  0.34,  3.09,  6.33, 
     0.16,  -5.90,  1.32,  -6.10,  -4.23,  0.52,  -5.32,  -1.63,  5.23,  -3.57,  2.28,  1.18,  -5.65,  -2.31,  -4.97,  -3.80,  -2.69,  -0.23,  5.28, 
     -2.61,  -5.93,  -3.01,  -5.63,  -6.28,  6.49,  -4.77,  -5.71,  -0.26,  -5.45,  -0.58,  4.28,  -6.29,  -11.46,  -4.30,  1.02,  -4.44,  -3.55,  -2.13,  18.08, 
     -0.42,  -1.20,  -2.01,  -1.80,  -1.11,  -1.54,  -2.21,  -1.26,  -1.50,  -1.14,  -1.40,  -1.28,  -1.24,  -1.34,  -0.78,  -0.83,  -0.78,  -0.49,  -0.93,  -2.24,  -1.20, 
     -4.22,  -2.53,  -0.44,  -3.85,  -4.50,  5.38,  -4.34,  1.17,  -0.08,  -4.03,  1.81,  -4.95,  -0.93,  -7.41,  -1.73,  -1.01,  -4.17,  -2.92,  0.66,  6.79,  -1.32,  10.92, 
     -1.12,  1.18,  -3.84,  1.90,  6.39,  -4.87,  -1.20,  -1.66,  -4.87,  3.14,  -5.21,  -3.10,  0.31,  0.24,  4.97,  1.45,  1.26,  0.04,  -4.52,  -5.51,  -1.20,  -3.43,  8.21 },
*/

  {10.00, 0.60},   /* gap open und extend penalties for an all positive matrix see: J.Mol.Biol.(1995) 249, 816 ff */

//  {7.50, 0.90},   /* gap open und extend penalties for a +/- matrix see: */
//  {15, 1.2},   /* gap open und extend penalties for a +/- matrix see: */
  {21.255, 1.396},   /* gap penalties for +/- matrices are calculated by Darwin  */

  0,
};

static score_m blosum_80 = 
{
  "blosum_80",
  
  80,                          /* matrix derived from a data base of blocks in which sequence segments that are
			           identical at >= 80 of aligned residues are clustered */ 

//  LN2/2,                       /* Beta = (ln2)/2  */
  1,                       /* Beta = (ln2)/2  */

  "ABCDEFGHIKLMNPQRSTVWXYZ",   /* amino acid order */ 

  {
     7,
    -3,  6,
    -1, -6, 13,
    -3,  6, -7, 10,
    -2,  1, -7,  2,  8,
    -4, -6, -4, -6, -6, 10,
     0, -2, -6, -3, -4, -6,  9,
    -3, -1, -7, -2,  0, -2, -4, 12,
    -3, -6, -2, -7, -6, -1, -7, -6,  7,
    -1, -1, -6, -2,  1, -5, -3, -1, -5,  8,
    -3, -7, -3, -7, -6,  0, -7, -5,  2, -4,  6,
    -2, -5, -3, -6, -4,  0, -5, -4,  2, -3,  3,  9,
    -3,  5, -5,  2, -1, -6, -1,  1, -6,  0, -6, -4,  9,
    -1, -4, -6, -3, -2, -6, -5, -4, -5, -2, -5, -4, -4, 12,
    -2, -1, -5, -1,  3, -5, -4,  1, -5,  2, -4, -1,  0, -3,  9,
    -3, -2, -6, -3, -1, -5, -4,  0, -5,  3, -4, -3, -1, -3,  1,  9,
     2,  0, -2, -1, -1, -4, -1, -2, -4, -1, -4, -3,  1, -2, -1, -2,  7,
     0, -1, -2, -2, -2, -4, -3, -3, -2, -1, -3, -1,  0, -3, -1, -2,  2,  8,
    -1, -6, -2, -6, -4, -2, -6, -5,  4, -4,  1,  1, -5, -4, -4, -4, -3,  0,  7,
    -5, -8, -5, -8, -6,  0, -6, -4, -5, -6, -4, -3, -7, -7, -4, -5, -6, -5, -5, 16,
    -1, -3, -4, -3, -2, -3, -3, -2, -2, -2, -2, -2, -2, -3, -2, -2, -1, -1, -2, -5, -2,
    -4, -5, -5, -6, -5,  4, -6,  3, -3, -4, -2, -3, -4, -6, -3, -4, -3, -3, -3,  3, -3, 11,
    -2,  0, -7,  1,  6, -6, -4,  0, -6,  1, -5, -3, -1, -2,  5,  0, -1, -2, -4, -5, -1, -4,  6 },


  {14.50, 0.04},   /* gap open und extend penalties for an all positive matrix see: J.Mol.Biol.(1995) 249, 816 ff */

  {7.00, 1.50},   /* gap open und extend penalties for a +/- matrix see: J.Mol.Biol.(1995) 249, 816 ff */

  0.0,
};



/* PAM matrices, the PAM matrix series is taken from the dbclustal header matrices.h */

static score_m pam_20 =
{
  "pam_20",
  
  20,                             

//  LN10/10,                        
  1,                        

  "ABCDEFGHIKLMNPQRSTVWXYZ",      

  {
     6,
    -5,  6,
    -8,-14, 10,
    -4,  6,-16,  8,
    -3,  0,-16,  2,  8,
    -9,-12,-15,-17,-16,  9,
    -3, -4,-11, -4, -5,-10,  7,
    -8, -2, -8, -5, -6, -7,-10,  9,
    -6, -7, -7, -9, -6, -3,-13,-11,  9,
    -8, -3,-16, -6, -5,-16, -8, -8, -7,  7,
    -7,-10,-17,-15,-10, -4,-12, -7, -2, -9,  7,
    -6,-12,-16,-13, -8, -5,-10,-13, -2, -3,  0, 11,
    -5,  6,-13,  1, -3,-10, -4, -1, -6, -2, -8,-11,  8,
    -2, -8, -9, -9, -7,-11, -7, -5,-10, -8, -8, -9, -7,  8,
    -5, -4,-16, -4,  0,-15, -8,  0, -9, -4, -6, -5, -5, -4,  9,
    -8, -9, -9,-12,-11,-10,-11, -3, -6, -1,-10, -5, -7, -5, -2,  9,
    -1, -2, -4, -5, -5, -7, -3, -7, -8, -5, -9, -6, -1, -3, -6, -4,  7,
    -1, -4, -9, -6, -7,-10, -7, -8, -3, -4, -8, -5, -3, -5, -7, -8,  0,  7,
    -3, -9, -7, -9, -8, -9, -7, -7,  1,-10, -3, -2, -9, -7, -8, -9, -8, -4,  7,
    -16,-11,-18,-17,-19, -6,-17, -8,-16,-14, -7,-15, -9,-16,-15, -3, -6,-15,-18, 13,
    -4, -6,-11, -7, -6, -9, -6, -6, -6, -6, -7, -6, -4, -6, -6, -7, -4, -5, -6,-13, -6,
    -9, -7, -5,-13, -9,  1,-16, -4, -7,-10, -8,-13, -5,-16,-14,-11, -8, -7, -8, -6, -9, 10,
    -4, -1,-16,  0,  6,-16, -6, -2, -7, -5, -8, -6, -4, -5,  7, -5, -6, -7, -8,-17, -6,-11,  6 },

  
  {12.50, 3.25}, /* !!!! These are the gap penalties for a pam30 matrix
		     (I think its bettter than guessing)
		     gap open und extend penalties for an all positive matrix see:
		     J.Mol.Biol.(1995) 249, 816 ff */ 

  {7.00, 1.00},  /* !!!! These are the gap penalties for a pam60+/-,
		    for pam30+/- {1.00, 3.00} was proposed - this is rather strange!
		    gap open und extend penalties for a +/- matrix see:
		    J.Mol.Biol.(1995) 249, 816 ff */ 

  0,
};

static score_m pam_60 =
{
  "pam_60",
  
  60,                            /* PAM distance */ 
  
//  LN10/10,                       /* Beta = (ln10)/10  */
  1,                       /* Beta = (ln10)/10  */
  
  "ABCDEFGHIKLMNPQRSTVWXYZ",     /* amino acid order */ 

  {
     5,
    -2,  5,
    -5, -9,  9,
    -2,  5,-10,  7,
    -1,  2,-10,  3,  7,
    -6, -8, -9,-11,-10,  8,
     0, -2, -7, -2, -2, -7,  6,
    -5,  0, -6, -2, -3, -4, -6,  8,
    -3, -4, -4, -5, -4, -1, -7, -6,  7,
    -5, -1,-10, -2, -3,-10, -5, -4, -4,  6,
    -4, -7,-11, -9, -7, -1, -8, -4,  0, -6,  6,
    -3, -6,-10, -7, -5, -2, -6, -7,  1,  0,  2, 10,
    -2,  5, -7,  2,  0, -6, -1,  1, -4,  0, -5, -6,  6,
     0, -4, -6, -5, -3, -7, -4, -2, -6, -4, -5, -6, -4,  7,
    -3, -1,-10, -1,  2, -9, -5,  2, -5, -1, -3, -2, -2, -1,  7,
    -5, -5, -6, -6, -6, -7, -7,  0, -4,  2, -6, -2, -3, -2,  0,  8,
     1,  0, -1, -2, -2, -5,  0, -4, -4, -2, -6, -4,  1,  0, -3, -2,  5,
     1, -2, -5, -3, -4, -6, -3, -5, -1, -2, -5, -2, -1, -2, -4, -4,  1,  6,
    -1, -5, -4, -6, -4, -5, -4, -5,  3, -6, -1,  0, -5, -4, -5, -5, -4, -1,  6,
    -10, -8,-12,-11,-12, -3,-11, -5,-10, -8, -4, -9, -6,-10, -9,  0, -4, -9,-11, 13,
    -2, -3, -6, -3, -3, -5, -3, -3, -3, -3, -4, -3, -2, -3, -3, -4, -2, -2, -3, -8, -3,
    -6, -5, -2, -8, -7,  3,-10, -2, -4, -7, -5, -7, -3,-10, -8, -8, -5, -5, -5, -3, -5,  9,
    -2,  1,-10,  2,  5,-10, -3,  0, -4, -2, -5, -4, -1, -2,  6, -2, -3, -4, -5,-11, -3, -7,  5 },

  
  {14.00, 1.50},   /* gap open und extend penalties for an all positive matrix see:
		     J.Mol.Biol.(1995) 249, 816 ff */

  {7.00, 1.00},   /* gap open und extend penalties for a +/- matrix see:
		    J.Mol.Biol.(1995) 249, 816 ff */

  0,
};

static score_m pam_120 =
{
  "pam_120",
  
  120,                           /* PAM distance */ 

//  LN10/10,                       /* Beta = (ln10)/10  */
  1,                       /* Beta = (ln10)/10  */

  "ABCDEFGHIKLMNPQRSTVWXYZ",     /* amino acid order */ 

  {
     3,
     0,  4,
    -3, -6,  9,
     0,  4, -7,  5,
     0,  3, -7,  3,  5,
    -4, -5, -6, -7, -7,  8,
     1,  0, -4,  0, -1, -5,  5,
    -3,  1, -4,  0, -1, -3, -4,  7,
    -1, -3, -3, -3, -3,  0, -4, -4,  6,
    -2,  0, -7, -1, -1, -7, -3, -2, -3,  5,
    -3, -4, -7, -5, -4,  0, -5, -3,  1, -4,  5,
    -2, -4, -6, -4, -3, -1, -4, -4,  1,  0,  3,  8,
    -1,  3, -5,  2,  1, -4,  0,  2, -2,  1, -4, -3,  4,
     1, -2, -4, -3, -2, -5, -2, -1, -3, -2, -3, -3, -2,  6,
    -1,  0, -7,  1,  2, -6, -3,  3, -3,  0, -2, -1,  0,  0,  6,
    -3, -2, -4, -3, -3, -5, -4,  1, -2,  2, -4, -1, -1, -1,  1,  6,
     1,  0,  0,  0, -1, -3,  1, -2, -2, -1, -4, -2,  1,  1, -2, -1,  3,
     1,  0, -3, -1, -2, -4, -1, -3,  0, -1, -3, -1,  0, -1, -2, -2,  2,  4,
     0, -3, -3, -3, -3, -3, -2, -3,  3, -4,  1,  1, -3, -2, -3, -3, -2,  0,  5,
    -7, -6, -8, -8, -8, -1, -8, -3, -6, -5, -3, -6, -4, -7, -6,  1, -2, -6, -8, 12,
    -1, -1, -4, -2, -1, -3, -2, -2, -1, -2, -2, -2, -1, -2, -1, -2, -1, -1, -1, -5, -2,
    -4, -3, -1, -5, -5,  4, -6, -1, -2, -5, -2, -4, -2, -6, -5, -5, -3, -3, -3, -2, -3,  8,
    -1,  2, -7,  3,  4, -6, -2,  1, -3, -1, -3, -2,  0, -1,  4, -1, -1, -2, -3, -7, -1, -5,  4 },

  
  {12.50, 1.00},   /* gap open und extend penalties for an all positive matrix see:
		     J.Mol.Biol.(1995) 249, 816 ff */

  {6.00, 1.40},   /* gap open und extend penalties for a +/- matrix see:
		    J.Mol.Biol.(1995) 249, 816 ff */
  0,

};

static score_m pam_160 =
{
  "pam_160",
  
  160,                           /* PAM distance */ 

//  LN10/10,                       /* Beta = (ln10)/10  */
  1,                       /* Beta = (ln10)/10  */

  "ABCDEFGHIKLMNPQRSTVWXYZ",     /* amino acid order */ 

  {
    2.0, 
    0.0, 3.0, 
    -2.0, -4.0, 9.0, 
    0.0, 3.0, -5.0, 4.0, 
    0.0, 2.0, -5.0, 3.0, 4.0, 
    -3.0, -4.0, -5.0, -6.0, -5.0, 7.0, 
    1.0, 0.0, -3.0, 0.0, 0.0, -4.0, 4.0, 
    -2.0, 1.0, -3.0, 0.0, 0.0, -2.0, -3.0, 6.0, 
    -1.0, -2.0, -2.0, -3.0, -2.0, 0.0, -3.0, -3.0, 5.0, 
    -2.0, 0.0, -5.0, 0.0, -1.0, -5.0, -2.0, -1.0, -2.0, 4.0, 
    -2.0, -4.0, -6.0, -4.0, -3.0, 1.0, -4.0, -2.0, 2.0, -3.0, 5.0, 
    -1.0, -3.0, -5.0, -3.0, -2.0, 0.0, -3.0, -3.0, 2.0, 0.0, 3.0, 7.0, 
    0.0, 2.0, -4.0, 2.0, 1.0, -3.0, 0.0, 2.0, -2.0, 1.0, -3.0, -2.0, 3.0, 
    1.0, -1.0, -3.0, -2.0, -1.0, -4.0, -1.0, -1.0, -2.0, -2.0, -3.0, -2.0, -1.0, 5.0, 
    -1.0, 1.0, -5.0, 1.0, 2.0, -5.0, -2.0, 2.0, -2.0, 0.0, -2.0, -1.0, 0.0, 0.0, 5.0, 
    -2.0, -1.0, -3.0, -2.0, -2.0, -4.0, -3.0, 1.0, -2.0, 3.0, -3.0, -1.0, -1.0, -1.0, 1.0, 6.0, 
    1.0, 0.0, 0.0, 0.0, 0.0, -3.0, 1.0, -1.0, -2.0, -1.0, -3.0, -2.0, 1.0, 1.0, -1.0, -1.0, 2.0, 
    1.0, 0.0, -2.0, -1.0, -1.0, -3.0, -1.0, -2.0, 0.0, 0.0, -2.0, -1.0, 0.0, 0.0, -1.0, -1.0, 1.0, 3.0, 
    0.0, -2.0, -2.0, -3.0, -2.0, -2.0, -2.0, -2.0, 3.0, -3.0, 1.0, 1.0, -2.0, -2.0, -2.0, -3.0, -1.0, 0.0, 4.0, 
    -5.0, -5.0, -7.0, -6.0, -7.0, -1.0, -7.0, -3.0, -5.0, -4.0, -2.0, -4.0, -4.0, -5.0, -5.0, 1.0, -2.0, -5.0, -6.0, 12.0, 
    0.0, -1.0, -3.0, -1.0, -1.0, -3.0, -1.0, -1.0, -1.0, -1.0, -2.0, -1.0, 0.0, -1.0, -1.0, -1.0, 0.0, 0.0, -1.0, -4.0, -1.0, 
    -3.0, -3.0, 0.0, -4.0, -4.0, 5.0, -5.0, 0.0, -2.0, -4.0, -2.0, -3.0, -2.0, -5.0, -4.0, -4.0, -3.0, -3.0, -3.0, -1.0, -3.0, 8.0, 
    0.0, 2.0, -5.0, 2.0, 3.0, -5.0, -1.0, 1.0, -2.0, 0.0, -3.0, -2.0, 1.0, -1.0, 3.0, 0.0, -1.0, -1.0, -2.0, -6.0, -1.0, -4.0, 3.0 },
  
  {12.50, 1.00},   /* gap open und extend penalties for an all positive matrix see:
		     J.Mol.Biol.(1995) 249, 816 ff */

  {6.00, 1.40},   /* gap open und extend penalties for a +/- matrix see:
		    J.Mol.Biol.(1995) 249, 816 ff */
  0,

};



static score_m pam_350  =
{
  "pam_350",
  
  350,                          /* PAM distance */ 

  LN10/10,                      /* Beta = (ln10)/10  */

  "ABCDEFGHIKLMNPQRSTVWXYZ",    /* amino acid order */ 

  {
     2,
     1,  3,
    -2, -5, 18,
     1,  3, -6,  4,
     1,  3, -6,  4,  4,
    -4, -5, -5, -6, -6, 13,
     2,  1, -4,  1,  1, -6,  5,
    -1,  1, -4,  1,  1, -2, -2,  7,
     0, -2, -3, -2, -2,  2, -2, -2,  5,
    -1,  1, -6,  1,  0, -6, -1,  1, -2,  5,
    -2, -4, -7, -4, -4,  3, -4, -2,  4, -3,  8,
    -1, -2, -6, -3, -2,  1, -3, -2,  3,  0,  5,  6,
     0,  2, -4,  2,  2, -4,  1,  2, -2,  1, -3, -2,  2,
     1,  0, -3,  0,  0, -5,  0,  0, -2, -1, -3, -2,  0,  6,
     0,  2, -6,  2,  3, -5, -1,  3, -2,  1, -2, -1,  1,  1,  4,
    -1,  0, -4, -1,  0, -5, -2,  2, -2,  4, -3,  0,  1,  0,  2,  7,
     1,  1,  0,  1,  0, -4,  1, -1, -1,  0, -3, -2,  1,  1,  0,  0,  1,
     1,  0, -2,  0,  0, -3,  1, -1,  0,  0, -2, -1,  1,  1,  0, -1,  1,  2,
     0, -2, -2, -2, -2, -1, -1, -2,  4, -2,  3,  2, -2, -1, -2, -3, -1,  0,  5,
    -7, -6,-10, -8, -8,  1, -8, -3, -6, -4, -2, -5, -5, -7, -5,  4, -3, -6, -7, 27,
     0,  0, -3, -1,  0, -2, -1,  0,  0, -1, -1,  0,  0,  0,  0, -1,  0,  0,  0, -5, -1,
    -4, -4,  1, -5, -5, 11, -6,  0,  0, -5,  0, -2, -3, -6, -5, -5, -3, -3, -2,  1, -2, 14,
     0,  2, -6,  3,  3, -6,  0,  2, -2,  1, -3, -2,  2,  0,  3,  1,  0,  0, -2, -7,  0, -5,  3 },


  
  {12.50, 0.40},   /* gap penalties for pam 300+;
		     gap open und extend penalties for an all positive matrix see:
		     J.Mol.Biol.(1995) 249, 816 ff */

  {9.00, 2.40},   /* gap penalties for pam 300+/-;
		    gap open und extend penalties for a +/- matrix see:
		    J.Mol.Biol.(1995) 249, 816 ff */
  0,

};
/* DNA mat from clustal w */
score_m dnamt =
{
  "dnamt",
  
  0,                      /* no distances defined */    

  1,                      /* Beta = 1 => look for a better value */

  "ABCDGHKMNRSTUVWXY",    /* nucleic acid order */ 
/*
  {
 10,
 -9, 10,
 -9, 10, 10,
 10, 10, -9, 10,
 -9, 10, -9, 10, 10,
 10, 10, 10, 10, -9, 10,
 -9, 10, -9, 10, 10, 10, 10,
 10, 10, 10, 10, -9, 10, -9, 10,
 10, 10, 10, 10, 10, 10, 10, 10, 10,
 10, 10, -9, 10, 10, 10, 10, 10, 10, 10,
 -9, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10,
 -9, 10, -9, 10, -9, 10, 10, -9, 10, -9, -9, 10,
 -9, 10, -9, 10, -9, 10, 10, -9, 10, -9, -9, 10, 10,
 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, -9, -9, 10,
 10, 10, -9, 10, -9, 10, 10, 10, 10, 10, -9, 10, 10, 10, 10,
 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10,
 -9, 10, 10, 10, -9, 10, 10, 10, 10, -9, 10, 10, 10, 10, 10, 10, 10},

  {0.0, 0.0},   

  {70.0, 7.0},   
*/

/*
  {
 1000,
 -900, 1000,
 -900, 1000, 1000,
 1000, 1000, -900, 1000,
 -900, 1000, -900, 1000, 1000,
 1000, 1000, 1000, 1000, -900, 1000,
 -900, 1000, -900, 1000, 1000, 1000, 1000,
 1000, 1000, 1000, 1000, -900, 1000, -900, 1000,
 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
 1000, 1000, -900, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
 -900, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
 -900, 1000, -900, 1000, -900, 1000, 1000, -900, 1000, -900, -900, 1000,
 -900, 1000, -900, 1000, -900, 1000, 1000, -900, 1000, -900, -900, 1000, 1000,
 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, -900, -900, 1000,
 1000, 1000, -900, 1000, -900, 1000, 1000, 1000, 1000, 1000, -900, 1000, 1000, 1000, 1000,
 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,
 -900, 1000, 1000, 1000, -900, 1000, 1000, 1000, 1000, -900, 1000, 1000, 1000, 1000, 1000, 1000, 1000},

  {0.0, 0.0},   

  {1500.0, 700.0},   
*/
/*
  {
    91, //A
    0,  0,
    -114,  0,  100, //C
    0,  0,  0,  0,
    -31,  0,  -125,  0,  100, //G
    0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
    -123,  0,  -31,  0,  -114,  0,  0,  0,  0,  0,  0,  91, //T
    -123,  0,  -31,  0,  -114,  0,  0,  0,  0,  0,  0,  0,  91, //U
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0},

  {0.0, 0.0},   

  {420.0, 150.0},   
*/

/*OLD from ClustalW*/

  {
    1,
    0,  0,
    0,  0,  1,
    0,  0,  0,  0,
    0,  0,  0,  0,  1,
    0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0},

  {0.0, 0.0},   

  {3, 1.0},   

//RIBOSUM85-60
/*
  {
    2.22,
    0,  0,
    -1.86,  0,  1.16,
    0,  0,  0,  0,
    -1.46,  0,  -2.48,  0,  1.03,
    0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
    -1.39,  0,  -1.05,  0,  -1.74,  0,  0,  0,  0,  0,  0,  1.65,
    -1.39,  0,  -1.05,  0,  -1.74,  0,  0,  0,  0,  0,  0,  0,  1.65,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0},

  {0.0, 0.0},   

  {2.5, 1.0},   
*/

  0,

};


/* gonnet matrices from clustalw(values are divided by 10), gap penalties are from Dayhoff matrices with
   corresponding pam distance calculated by Darwin_2.x */ 

static score_m gonnet_40 =
{
  "gonnet_40",
  
  40,                           /* PAM distance */    

//  LN10/10,                      /* Beta = (ln10)/10  */
  1,                      /* Beta = (ln10)/10  */

  "ABCDEFGHIKLMNPQRSTVWXYZ",    /* amino acid order */ 

  
  {
     9.2,
     0.0,  0.0,
    -3.1,  0.0, 16.3,
    -5.6,  0.0,-13.5, 11.1,
    -3.7,  0.0,-14.0,  1.6, 10.5,
    -9.2,  0.0, -6.4,-15.2,-14.3, 12.6,
    -3.2,  0.0, -9.1, -5.1, -7.6,-15.2, 10.5,
    -6.5,  0.0, -6.7, -4.1, -4.0, -5.0, -8.1, 14.5,
    -7.6,  0.0, -8.7,-15.0,-10.6, -3.9,-15.8, -9.4, 10.4,
    -5.4,  0.0,-13.2, -4.7, -1.3,-12.7, -7.9, -3.4, -8.6, 10.3,
    -6.8,  0.0, -8.5,-15.5,-10.8, -1.3,-14.1, -8.5,  0.5, -8.5,  8.9,
    -4.5,  0.0, -6.3,-13.0, -8.0, -1.6,-11.4, -6.0,  1.0, -5.7,  1.6, 14.0,
    -6.2,  0.0, -8.3,  0.6, -3.8,-10.4, -4.0, -0.7, -9.9, -2.0,-11.2, -9.1, 11.5,
    -3.7,  0.0,-13.7, -6.9, -6.0,-12.8, -8.7, -7.1,-10.8, -6.2, -8.3,-11.9, -7.8, 12.4,
    -4.3,  0.0,-11.3, -3.2,  1.0,-10.0, -7.1,  0.0, -9.1,  0.2, -6.0, -3.5, -2.5, -4.6, 11.8,
    -6.1,  0.0, -8.6, -7.7, -5.0,-13.0, -6.9, -3.1,-10.3,  1.9, -8.4, -8.1, -4.7, -7.3, -0.6, 11.2,
     0.0,  0.0, -3.5, -3.6, -4.1,-11.1, -3.7, -4.8, -9.5, -4.3, -9.5, -6.4, -1.1, -3.5, -3.5, -5.1,  9.9,
    -2.5,  0.0, -5.9, -4.7, -5.2, -9.0, -8.5, -4.6, -5.1, -3.4, -7.8, -4.4, -2.7, -4.2, -3.9, -5.2,  1.3, 10.0,
    -2.2,  0.0, -4.3,-13.3, -7.4, -5.8,-12.2, -9.8,  2.8, -8.2, -1.8, -2.2,-10.3, -8.6, -7.9, -8.8, -7.4, -2.5,  9.7,
   -12.0,  0.0, -6.8,-17.1,-13.1, -0.6,-10.8, -7.0, -9.3,-12.7, -7.1, -7.2,-11.9,-14.9, -8.7, -6.3, -9.8,-12.0,-11.5, 18.1,
     0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,
    -9.5,  0.0, -5.6, -9.8,-10.7,  3.1,-12.9,  0.5, -7.6, -8.8, -6.4, -6.6, -6.2,-10.6, -8.1, -7.5, -6.9, -8.7, -7.3,  0.1,  0.0, 13.5,
     0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0
  },


  {0.0, 0.0},         /* no gap penalties for all + matrices are defined */

  {25.73, 1.396},   /* gap penalties for +/- matrices are calculated by Darwin  */

  0,
};


static score_m gonnet_80 =
{
  "gonnet_80",
  
  80,                           /* PAM distance */    

//  LN10/10,                      /* Beta = (ln10)/10  */
  1,                      /* Beta = (ln10)/10  */

  "ABCDEFGHIKLMNPQRSTVWXYZ",    /* amino acid order */ 

  
  {
    7.5,
    0.0,  0.0,
   -1.0,  0.0, 15.4,
   -3.1,  0.0, -9.3,  9.6,
   -1.7,  0.0, -9.4,  3.1,  8.8,
   -6.4,  0.0, -3.9,-11.1,-10.2, 11.4,
   -1.1,  0.0, -6.1, -2.6, -4.7,-11.5,  9.7,
   -3.9,  0.0, -4.3, -1.7, -1.7, -2.6, -5.3, 12.7,
   -4.3,  0.0, -5.4,-10.6, -7.3, -1.5,-11.4, -6.4,  8.6,
   -3.0,  0.0, -8.8, -2.1,  0.4, -8.9, -5.0, -1.2, -5.9,  8.5,
   -4.3,  0.0, -5.5,-10.9, -7.5,  0.7,-10.4, -5.7,  2.2, -5.8,  7.7,
   -2.6,  0.0, -3.9, -8.8, -5.3,  0.3, -8.3, -3.8,  2.5, -3.7,  3.1, 11.7,
   -3.4,  0.0, -5.5,  2.1, -1.3, -7.5, -1.8,  0.9, -7.1, -0.2, -7.9, -6.2,  9.7,
   -1.6,  0.0, -9.3, -4.2, -3.5, -9.3, -5.8, -4.5, -7.5, -3.7, -5.8, -7.8, -4.8, 11.4,
   -2.2,  0.0, -7.6, -0.9,  2.3, -7.0, -4.4,  1.4, -6.0,  1.7, -3.9, -1.9, -0.6, -2.4,  9.5,
   -3.6,  0.0, -6.0, -4.4, -2.3, -9.0, -4.3, -1.0, -7.1,  3.3, -5.8, -5.3, -2.2, -4.5,  1.1,  9.7,
    1.4,  0.0, -1.5, -1.4, -1.9, -7.7, -1.6, -2.5, -6.2, -2.0, -6.4, -4.1,  0.5, -1.4, -1.5, -2.7,  7.8,
   -0.5,  0.0, -3.4, -2.4, -2.7, -6.2, -5.2, -2.4, -2.8, -1.5, -4.9, -2.5, -0.7, -2.0, -1.8, -2.7,  2.5,  8.1,
   -0.6,  0.0, -2.1, -8.9, -5.1, -3.1, -8.6, -6.5,  4.1, -5.4,  0.3,  0.1, -6.9, -5.7, -5.1, -6.0, -4.3, -0.9,  8.0,
   -8.7,  0.0, -4.3,-12.4, -9.8,  1.6, -8.1, -4.3, -6.3, -8.9, -4.4, -4.5, -8.6,-11.2, -6.2, -4.1, -7.2, -8.7, -8.0, 17.3,
    0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,
   -6.5,  0.0, -3.2, -6.9, -7.4,  4.9, -9.4,  2.1, -4.7, -6.0, -3.5, -3.7, -3.9, -7.6, -5.3, -5.0, -4.6, -5.8, -4.7,  2.3,  0.0, 12.3,
    0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0
  },

  
  {0.0, 0.0},         /* no gap penalties for all + matrices are defined */

  {23.492, 1.396},   /* gap penalties for +/- matrices are calculated by Darwin  */

  0,
};


static score_m gonnet_120 =
{
  "gonnet_120",
  
  120,                           /* PAM distance */    

//  LN10/10,                      /* Beta = (ln10)/10  */
  1,                      /* Beta = (ln10)/10  */

  "ABCDEFGHIKLMNPQRSTVWXYZ",    /* amino acid order */ 

  
  {
    5.9,
    0.0,  0.0,
   -0.1,  0.0, 14.4,
   -1.8,  0.0, -6.9,  8.2,
   -0.9,  0.0, -6.8,  3.5,  7.2,
   -4.8,  0.0, -2.6, -8.7, -7.8, 10.2,
   -0.3,  0.0, -4.5, -1.4, -3.1, -9.2,  9.0,
   -2.6,  0.0, -3.1, -0.7, -0.6, -1.4, -3.7, 11.0,
   -2.7,  0.0, -3.6, -8.0, -5.5, -0.3, -8.7, -4.8,  7.2,
   -1.9,  0.0, -6.4, -0.8,  1.1, -6.7, -3.4, -0.2, -4.4,  6.9,
   -3.0,  0.0, -3.9, -8.2, -5.7,  1.5, -8.2, -4.2,  2.8, -4.4,  6.6,
   -1.7,  0.0, -2.6, -6.4, -4.0,  1.1, -6.5, -2.8,  2.9, -2.7,  3.4,  9.5,
   -2.0,  0.0, -4.1,  2.6, -0.1, -5.8, -0.7,  1.4, -5.5,  0.5, -6.1, -4.6,  8.0,
   -0.6,  0.0, -6.8, -2.8, -2.2, -7.2, -4.1, -3.1, -5.6, -2.4, -4.4, -5.6, -3.2, 10.5,
   -1.2,  0.0, -5.6,  0.1,  2.5, -5.3, -3.0,  1.7, -4.3,  2.0, -3.0, -1.4,  0.1, -1.4,  7.4,
   -2.3,  0.0, -4.5, -2.7, -1.0, -6.8, -3.0, -0.1, -5.3,  3.6, -4.4, -3.8, -1.0, -3.0,  1.6,  8.3,
    1.6,  0.0, -0.7, -0.5, -0.9, -5.8, -0.6, -1.4, -4.4, -1.0, -4.7, -2.9,  1.0, -0.5, -0.7, -1.5,  6.0,
    0.2,  0.0, -2.1, -1.3, -1.5, -4.7, -3.5, -1.4, -1.7, -0.6, -3.4, -1.6,  0.0, -1.0, -0.9, -1.6,  2.6,  6.4,
    0.0,  0.0, -1.1, -6.5, -3.8, -1.7, -6.5, -4.7,  4.2, -3.9,  1.3,  1.0, -5.0, -4.2, -3.6, -4.4, -2.8, -0.3,  6.5,
   -6.8,  0.0, -2.9, -9.6, -7.8,  2.7, -6.6, -2.8, -4.6, -6.8, -2.9, -3.1, -6.8, -8.9, -4.9, -3.0, -5.7, -6.7, -5.9, 16.6,
    0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,
   -4.8,  0.0, -2.0, -5.3, -5.6,  5.5, -7.4,  2.6, -3.1, -4.4, -2.0, -2.2, -2.8, -5.9, -3.8, -3.7, -3.5, -4.2, -3.3,  3.3,  0.0, 11.1,
    0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0  
  },


  
  {0.0, 0.0},          /* no gap penalties for all + matrices are defined */

  {22.183, 1.396},   /* gap penalties for +/- matrices are calculated by Darwin  */

  0,
};


static score_m gonnet_160 =
{
  "gonnet_160",
  
  160,                           /* PAM distance */    

//  LN10/10,                      /* Beta = (ln10)/10  */
//Usman
  1,                      /* Beta = (ln10)/10  */

  "ABCDEFGHIKLMNPQRSTVWXYZ",    /* amino acid order */ 

  
  {
    4.6,
    0.0,  0.0,
    0.3,  0.0, 13.5,
   -1.1,  0.0, -5.3,  7.0,
   -0.4,  0.0, -5.2,  3.4,  5.9,
   -3.8,  0.0, -1.8, -7.0, -6.2,  9.1,
    0.2,  0.0, -3.4, -0.7, -2.1, -7.6,  8.2,
   -1.8,  0.0, -2.3, -0.1, -0.1, -0.7, -2.7,  9.3,
   -1.8,  0.0, -2.5, -6.2, -4.3,  0.3, -7.0, -3.7,  5.9,
   -1.2,  0.0, -4.8, -0.1,  1.3, -5.3, -2.4,  0.2, -3.5,  5.5,
   -2.2,  0.0, -2.9, -6.5, -4.5,  1.9, -6.7, -3.2,  3.0, -3.4,  5.7,
   -1.2,  0.0, -1.9, -5.0, -3.1,  1.4, -5.2, -2.1,  2.9, -2.1,  3.4,  7.6,
   -1.2,  0.0, -3.1,  2.6,  0.5, -4.7, -0.2,  1.5, -4.4,  0.8, -4.8, -3.6,  6.5,
   -0.1,  0.0, -5.2, -1.9, -1.4, -5.8, -3.0, -2.2, -4.3, -1.6, -3.5, -4.2, -2.2,  9.6,
   -0.7,  0.0, -4.2,  0.6,  2.3, -4.1, -2.1,  1.7, -3.2,  2.0, -2.4, -1.2,  0.5, -0.8,  5.6,
   -1.6,  0.0, -3.5, -1.6, -0.3, -5.3, -2.1,  0.3, -4.1,  3.5, -3.5, -2.9, -0.4, -2.1,  1.7,  7.1,
    1.6,  0.0, -0.2,  0.0, -0.3, -4.5, -0.1, -0.8, -3.3, -0.4, -3.6, -2.3,  1.1,  0.0, -0.2, -0.9,  4.4,
    0.5,  0.0, -1.4, -0.6, -0.8, -3.6, -2.4, -0.8, -1.2, -0.2, -2.4, -1.1,  0.3, -0.4, -0.4, -0.9,  2.3,  5.0,
    0.1,  0.0, -0.6, -4.9, -3.0, -0.8, -5.2, -3.5,  4.0, -3.0,  1.7,  1.4, -3.8, -3.2, -2.7, -3.4, -2.0,  0.0,  5.3,
   -5.5,  0.0, -2.1, -7.8, -6.4,  3.2, -5.5, -1.9, -3.4, -5.4, -2.0, -2.2, -5.5, -7.4, -4.0, -2.4, -4.7, -5.4, -4.5, 15.8,
    0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,
   -3.7,  0.0, -1.3, -4.2, -4.4,  5.6, -6.0,  2.7, -2.0, -3.5, -1.1, -1.3, -2.2, -4.8, -2.9, -2.9, -2.8, -3.2, -2.4,  3.8,  0.0, 10.0,
    0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0
  },

  
  {0.0, 0.0},          /* no gap penalties for all + matrices are defined */

  {21.255, 1.396},   /* gap penalties for +/- matrices are calculated by Darwin  */

  0,
};


static score_m gonnet_200 =
{
  "gonnet_200",
  
  200,                           /* PAM distance */    

//  LN10/10,                      /* Beta = (ln10)/10  */
  1,                      /* Beta = (ln10)/10  */

  "ABCDEFGHIKLMNPQRSTVWXYZ",    /* amino acid order */ 

   {
    3.5, 
    0.0, 0.0, 
    0.0, 0.0, 12.6, 
    -0.6, 0.0, -4.2, 5.9, 
    -0.2, 0.0, -4.0, 3.1, 4.8, 
    -3.0, 0.0, -1.2, -5.7, -5.0, 8.1, 
    0.4, 0.0, -2.6, 0.0, 0.0, 0.0, 7.5, 
    -1.3, 0.0, -1.8, 0.2, 0.2, 0.0, -2.0, 7.8, 
    -1.2, 0.0, -1.8, -5.0, -3.4, 0.0, -5.7, -2.9, 5.0, 
    -0.7, 0.0, -3.7, 0.3, 1.3, 0.0, -1.7, 0.5, 0.0, 4.4, 
    -1.6, 0.0, -2.1, -5.2, -3.6, 0.0, -5.5, -2.5, 3.0, -2.7, 4.9, 
    -0.9, 0.0, -1.4, -3.9, -2.5, 0.0, -4.3, -1.7, 0.0, -1.8, 0.0, 5.9, 
    -0.7, 0.0, -2.4, 0.0, 0.0, 0.0, 0.1, 0.0, 0.0, 0.0, 0.0, 0.0, 5.2, 
    0.0, 0.0, -4.1, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8.7, 
    -0.4, 0.0, -3.3, 0.8, 2.1, 0.0, -1.5, 0.0, 0.0, 0.0, 0.0, 0.0, 0.6, -0.5, 4.1, 
    -1.1, 0.0, -2.8, -0.9, 0.2, 0.0, -1.5, 0.5, 0.0, 0.0, 0.0, 0.0, 0.0, -1.5, 1.7, 6.0, 
    0.0, 0.0, -0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 3.3, 
    0.0, 0.0, -0.9, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.9, 3.7, 
    0.1, 0.0, -0.3, -3.9, -2.4, 0.0, -4.2, -2.7, 3.6, -2.3, 1.8, 1.6, -3.0, -2.5, -2.1, -2.6, -1.5, 0.0, 4.3, 
    -4.5, 0.0, -1.5, -6.4, -5.3, 3.5, -4.8, -1.3, -2.6, -4.4, -1.3, -1.6, -4.5, -6.1, -3.3, -2.0, -4.0, -4.4, -3.5, 15.1, 
    0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 
    -2.9, 0.0, -0.8, -3.5, -3.5, 5.4, -5.0, 2.5, -1.3, -2.8, -0.5, -0.7, -1.8, -3.9, -2.3, -2.3, -2.3, -2.5, -1.7, 0.0, 0.0, 9.0, 
    0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0
  },
  
  {0.0, 0.0},          /* no gap penalties for all + matrices are defined */

  {20.534, 1.396},   /* gap penalties for +/- matrices are calculated by Darwin  */

  0,
};



static score_m gonnet_250 =
{
  "gonnet_250",
  
  250,                           /* PAM distance */    

//  LN10/10,                      /* Beta = (ln10)/10  */
  1,                      /* Beta = (ln10)/10  */

  "ABCDEFGHIKLMNPQRSTVWXYZ",    /* amino acid order */ 

  
  {
    2.4,
    0.0,  0.0,
    0.5,  0.0, 11.5,
   -0.3,  0.0, -3.2,  4.7,
    0.0,  0.0, -3.0,  2.7,  3.6,
   -2.3,  0.0, -0.8, -4.5, -3.9,  7.0,
    0.5,  0.0, -2.0,  0.1, -0.8, -5.2,  6.6,
   -0.8,  0.0, -1.3,  0.4,  0.4, -0.1, -1.4,  6.0,
   -0.8,  0.0, -1.1, -3.8, -2.7,  1.0, -4.5, -2.2,  4.0,
   -0.4,  0.0, -2.8,  0.5,  1.2, -3.3, -1.1,  0.6, -2.1,  3.2,
   -1.2,  0.0, -1.5, -4.0, -2.8,  2.0, -4.4, -1.9,  2.8, -2.1,  4.0,
   -0.7,  0.0, -0.9, -3.0, -2.0,  1.6, -3.5, -1.3,  2.5, -1.4,  2.8,  4.3,
   -0.3,  0.0, -1.8,  2.2,  0.9, -3.1,  0.4,  1.2, -2.8,  0.8, -3.0, -2.2,  3.8,
    0.3,  0.0, -3.1, -0.7, -0.5, -3.8, -1.6, -1.1, -2.6, -0.6, -2.3, -2.4, -0.9,  7.6,
   -0.2,  0.0, -2.4,  0.9,  1.7, -2.6, -1.0,  1.2, -1.9,  1.5, -1.6, -1.0,  0.7, -0.2,  2.7,
   -0.6,  0.0, -2.2, -0.3,  0.4, -3.2, -1.0,  0.6, -2.4,  2.7, -2.2, -1.7,  0.3, -0.9,  1.5,  4.7,
    1.1,  0.0,  0.1,  0.5,  0.2, -2.8,  0.4, -0.2, -1.8,  0.1, -2.1, -1.4,  0.9,  0.4,  0.2, -0.2,  2.2,
    0.6,  0.0, -0.5,  0.0, -0.1, -2.2, -1.1, -0.3, -0.6,  0.1, -1.3, -0.6,  0.5,  0.1,  0.0, -0.2,  1.5,  2.5,
    0.1,  0.0,  0.0, -2.9, -1.9,  0.1, -3.3, -2.0,  3.1, -1.7,  1.8,  1.6, -2.2, -1.8, -1.5, -2.0, -1.0,  0.0,  3.4,
   -3.6,  0.0, -1.0, -5.2, -4.3,  3.6, -4.0, -0.8, -1.8, -3.5, -0.7, -1.0, -3.6, -5.0, -2.7, -1.6, -3.3, -3.5, -2.6, 14.2,
    0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,
   -2.2,  0.0, -0.5, -2.8, -2.7,  5.1, -4.0,  2.2, -0.7, -2.1,  0.0, -0.2, -1.4, -3.1, -1.7, -1.8, -1.9, -1.9, -1.1,  4.1,  0.0,  7.8,
    0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0  
  },

  
  {0.0, 0.0},          /* no gap penalties for all + matrices are defined */

  {19.814, 1.396},   /* gap penalties for +/- matrices are calculated by Darwin  */

  0,
};



static score_m gonnet_300 =
{
  "gonnet_300",
  
  300,                           /* PAM distance */    

//  LN10/10,                      /* Beta = (ln10)/10  */
  1,                      /* Beta = (ln10)/10  */

  "ABCDEFGHIKLMNPQRSTVWXYZ",    /* amino acid order */ 

  
  {
    1.6,
    0.0,  0.0,
    0.5,  0.0, 10.4,
   -0.1,  0.0, -2.4,  3.7,
    0.1,  0.0, -2.3,  2.3,  2.7,
   -1.8,  0.0, -0.5, -3.7, -3.1,  6.0,
    0.5,  0.0, -1.5,  0.3, -0.4, -4.2,  5.8,
   -0.6,  0.0, -1.0,  0.5,  0.4,  0.0, -1.0,  4.5,
   -0.6,  0.0, -0.7, -3.0, -2.1,  1.1, -3.6, -1.6,  3.3,
   -0.2,  0.0, -2.1,  0.6,  1.1, -2.6, -0.7,  0.5, -1.7,  2.4,
   -0.9,  0.0, -1.0, -3.2, -2.2,  1.9, -3.6, -1.4,  2.5, -1.7,  3.3,
   -0.5,  0.0, -0.6, -2.4, -1.6,  1.5, -2.8, -1.0,  2.2, -1.1,  2.4,  3.1,
   -0.1,  0.0, -1.4,  1.8,  0.9, -2.5,  0.5,  1.0, -2.2,  0.8, -2.4, -1.7,  2.7,
    0.3,  0.0, -2.3, -0.4, -0.2, -3.0, -1.1, -0.8, -2.0, -0.3, -1.8, -1.9, -0.6,  6.6,
   -0.1,  0.0, -1.8,  0.9,  1.4, -2.0, -0.6,  0.9, -1.5,  1.3, -1.3, -0.8,  0.7, -0.1,  1.8,
   -0.4,  0.0, -1.7,  0.0,  0.5, -2.5, -0.6,  0.6, -1.9,  2.2, -1.8, -1.3,  0.4, -0.6,  1.3,  3.7,
    0.8,  0.0,  0.1,  0.5,  0.3, -2.2,  0.4, -0.1, -1.4,  0.2, -1.7, -1.1,  0.7,  0.4,  0.2,  0.0,  1.5,
    0.5,  0.0, -0.3,  0.1,  0.1, -1.7, -0.7, -0.1, -0.4,  0.2, -0.9, -0.5,  0.4,  0.2,  0.1, -0.1,  1.1,  1.7,
    0.0,  0.0,  0.1, -2.3, -1.5,  0.4, -2.6, -1.5,  2.6, -1.3,  1.7,  1.5, -1.7, -1.4, -1.2, -1.5, -0.8,  0.0,  2.6,
   -2.9,  0.0, -0.7, -4.2, -3.6,  3.6, -3.4, -0.5, -1.3, -2.8, -0.4, -0.6, -3.0, -4.1, -2.3, -1.4, -2.7, -2.8, -1.9, 13.2,
    0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,
   -1.7,  0.0, -0.3, -2.2, -2.2,  4.6, -3.3,  1.8, -0.3, -1.7,  0.3,  0.1, -1.2, -2.5, -1.4, -1.4, -1.5, -1.5, -0.7,  4.0,  0.0,  6.7,
    0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0
  },

  
  {0.0, 0.0},          /* no gap penalties for all + matrices are defined */

  {19.225, 1.396},   /* gap penalties for +/- matrices are calculated by Darwin  */

  0,
};



static score_m gonnet_350 =
{
  "gonnet_350",
  
  350,                           /* PAM distance */    

//  LN10/10,                      /* Beta = (ln10)/10  */
  1,                      /* Beta = (ln10)/10  */

  "ABCDEFGHIKLMNPQRSTVWXYZ",    /* amino acid order */ 

  
  {
    1.0,
    0.0,  0.0,
    0.4,  0.0,  9.3,
    0.0,  0.0, -1.9,  2.9,
    0.1,  0.0, -1.7,  1.9,  2.0,
   -1.4,  0.0, -0.3, -3.0, -2.5,  5.1,
    0.5,  0.0, -1.2,  0.4, -0.2, -3.5,  5.1,
   -0.4,  0.0, -0.8,  0.5,  0.4,  0.1, -0.7,  3.3,
   -0.4,  0.0, -0.5, -2.4, -1.7,  1.1, -2.9, -1.3,  2.7,
   -0.1,  0.0, -1.6,  0.6,  0.9, -2.1, -0.4,  0.5, -1.3,  1.8,
   -0.7,  0.0, -0.7, -2.5, -1.8,  1.8, -3.0, -1.1,  2.2, -1.4,  2.8,
   -0.4,  0.0, -0.4, -1.9, -1.3,  1.4, -2.3, -0.8,  1.9, -0.9,  2.1,  2.3,
    0.0,  0.0, -1.1,  1.5,  0.9, -2.0,  0.5,  0.8, -1.8,  0.7, -1.9, -1.4,  2.0,
    0.3,  0.0, -1.8, -0.2,  0.0, -2.5, -0.7, -0.5, -1.6, -0.2, -1.5, -1.4, -0.3,  5.6,
    0.0,  0.0, -1.4,  0.8,  1.1, -1.6, -0.4,  0.7, -1.1,  1.0, -1.1, -0.7,  0.6,  0.0,  1.2,
   -0.2,  0.0, -1.3,  0.2,  0.6, -2.0, -0.4,  0.6, -1.5,  1.8, -1.4, -1.1,  0.4, -0.4,  1.0,  2.8,
    0.6,  0.0,  0.1,  0.5,  0.3, -1.8,  0.5,  0.0, -1.1,  0.2, -1.3, -0.9,  0.6,  0.4,  0.2,  0.1,  1.0,
    0.4,  0.0, -0.2,  0.2,  0.1, -1.3, -0.5, -0.1, -0.3,  0.2, -0.7, -0.4,  0.4,  0.2,  0.1,  0.0,  0.8,  1.1,
    0.0,  0.0,  0.2, -1.8, -1.2,  0.5, -2.1, -1.1,  2.2, -1.0,  1.6,  1.4, -1.3, -1.1, -0.9, -1.2, -0.6,  0.0,  2.1,
   -2.4,  0.0, -0.4, -3.5, -2.9,  3.5, -3.0, -0.3, -0.9, -2.3, -0.1, -0.3, -2.4, -3.4, -1.9, -1.2, -2.2, -2.3, -1.4, 12.4,
    0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,
   -1.4,  0.0, -0.1, -1.8, -1.7,  4.2, -2.7,  1.5, -0.1, -1.4,  0.5,  0.2, -1.0, -2.0, -1.1, -1.2, -1.2, -1.2, -0.4,  3.9,  0.0,  5.7,
    0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0
  },

      
  {0.0, 0.0},          /* no gap penalties for all + matrices are defined */

  {18.727, 1.396},   /* gap penalties for +/- matrices are calculated by Darwin  */

  0,
};

static score_m vtml_160 =
{
  "vtml_160",
  
  160,                           /* PAM distance */    

//  LN10/10,                      /* Beta = (ln10)/10  */
  1,                      /* Beta = (ln10)/10  */

  "ABCDEFGHIKLMNPQRSTVWXYZ",    /* amino acid order */ 
  
  {
    5, 
    -1, 5, 
    1, -4, 13, 
    -1, 5, -6, 8, 
    -1, 2, -5, 3, 6, 
    -3, -6, -4, -8, -6, 9, 
    0, -1, -3, -1, -2, -6, 8, 
    -2, 0, -2, 0, -1, 0, -3, 10, 
    -2, -5, -1, -6, -5, 0, -7, -4, 6, 
    -1, 0, -5, 0, 1, -6, -3, 0, -4, 6, 
    -2, -6, -4, -7, -4, 2, -7, -3, 3, -4, 6, 
    -1, -4, -1, -5, -4, 1, -5, -4, 2, -2, 4, 8, 
    -1, 5, -3, 3, 0, -5, 0, 1, -5, 0, -5, -3, 7, 
    0, -2, -4, -2, -1, -5, -3, -2, -5, -1, -3, -4, -2, 10, 
    -1, 0, -5, 0, 3, -4, -3, 2, -4, 2, -3, -1, 0, -1, 6, 
    -2, -2, -3, -3, -2, -5, -3, 1, -4, 4, -4, -2, -1, -2, 2, 8, 
    1, 0, 1, 0, 0, -3, 0, -1, -4, -1, -4, -3, 1, 0, 0, -1, 5, 
    1, 0, -1, -1, -1, -3, -3, -1, -1, -1, -2, -1, 0, -1, -1, -2, 2, 6, 
    0, -4, 1, -5, -3, -1, -5, -4, 4, -3, 2, 1, -4, -3, -3, -4, -2, 0, 5, 
    -5, -6, -7, -7, -8, 3, -5, -2, -2, -5, -2, -4, -6, -5, -7, -4, -4, -7, -5, 16, 
    -1, -2, -2, -2, -2, -2, -3, -1, -2, -1, -2, -1, -1, -2, -1, -2, -1, -1, -2, -3, -2, 
    -4, -4, -1, -6, -4, 6, -6, 3, -2, -4, -1, -3, -2, -6, -4, -3, -2, -3, -3, 4, -2, 10, 
    -1, 1, -5, 2, 4, -5, -2, 0, -4, 2, -3, -2, 0, -1, 4, 0, 0, -1, -3, -7, -1, -4, 4
  },

  {0.0, 0.0},   /* gap open und extend penalties for an all positive matrix */

//  {14.0, 2.0},
  {10.0, 2.0},

  0.0,
      
};

static score_m vtml_190 =
{
  "vtml_190",
  
  190,                           /* PAM distance */    

//  LN10/10,                      /* Beta = (ln10)/10  */
  1,                      /* Beta = (ln10)/10  */

  "ABCDEFGHIKLMNPQRSTVWXYZ",    /* amino acid order */ 
  
  {
    27, 
    -6, 30, 
    8, -23, 84, 
    -7, 31, -30, 45, 
    -4, 12, -29, 22, 36, 
    -19, -36, -24, -44, -35, 56, 
    2, -2, -14, -4, -9, -38, 52, 
    -11, 4, -13, 0, -3, 0, -15, 57, 
    -8, -31, -2, -36, -27, 2, -41, -22, 35, 
    -7, 2, -26, 0, 9, -32, -13, 0, -23, 33, 
    -13, -32, -20, -38, -25, 11, -38, -16, 19, -21, 35, 
    -8, -23, -4, -28, -20, 10, -31, -20, 16, -12, 23, 46, 
    -5, 29, -15, 18, 3, -27, -1, 7, -26, 4, -27, -19, 39, 
    -1, -10, -20, -8, -7, -28, -17, -11, -27, -7, -20, -24, -13, 60, 
    -5, 4, -25, 4, 16, -23, -14, 11, -21, 12, -15, -8, 3, -4, 35, 
    -11, -9, -19, -16, -7, -28, -15, 6, -24, 26, -21, -13, -2, -10, 12, 46, 
    9, 4, 5, 0, -1, -18, 0, -3, -20, -3, -20, -16, 8, 0, -1, -6, 26, 
    5, -1, -1, -5, -5, -18, -13, -6, -4, -3, -12, -4, 3, -7, -3, -8, 13, 32, 
    2, -25, 5, -27, -20, -4, -29, -20, 26, -19, 11, 10, -22, -18, -16, -22, -13, -1, 31, 
    -31, -37, -40, -42, -45, 19, -32, -7, -13, -29, -7, -22, -33, -31, -39, -24, -25, -37, -28, 102, 
    -5, -9, -9, -11, -9, -10, -15, -2, -10, -7, -10, -7, -6, -11, -5, -8, -4, -5, -8, -17, -8, 
    -20, -22, -3, -31, -21, 36, -33, 18, -13, -21, -5, -12, -12, -36, -22, -17, -13, -18, -15, 26, -7, 62, 
    -5, 8, -27, 13, 26, -29, -12, 4, -24, 11, -20, -14, 3, -6, 26, 2, -1, -4, -18, -42, -7, -21, 26, 
  },

  {0.0, 0.0},   /* gap open und extend penalties for an all positive matrix */

  {80.0, 7.0},  /* gap open und extend penalties for a +/- matrix */

  0.0,
      
};

static score_m vtml_240 =
{
  "vtml_240",
  
  240,                  

//  LN10/10,                      
  1,                      

  "ABCDEFGHIKLMNPQRSTVWXYZ",  
  
  {
    58, 
    0.0, 0.0, 
    23, 0.0, 224, 
    -12, 0.0, -67, 111, 
    -7, 0.0, -63, 59, 85, 
    -44, 0.0, -50, -104, -83, 144, 
    10, 0.0, -30, -4, -17, -93, 140, 
    -23, 0.0, -29, 4, -1, 4, -32, 137, 
    -14, 0.0, 1, -84, -63, 12, -95, -50, 86, 
    -14, 0.0, -56, 6, 25, -74, -27, 6, -53, 75, 
    -27, 0.0, -41, -88, -60, 36, -91, -37, 53, -48, 88, 
    -17, 0.0, -6, -65, -47, 30, -75, -42, 47, -30, 62, 103, 
    -8, 0.0, -33, 48, 15, -64, 4, 21, -62, 13, -63, -45, 89, 
    1, 0.0, -44, -13, -12, -67, -36, -23, -60, -12, -48, -54, -25, 160, 
    -9, 0.0, -53, 18, 40, -56, -29, 27, -47, 34, -36, -21, 12, -6, 75, 
    -22, 0.0, -43, -29, -8, -65, -32, 19, -55, 68, -48, -31, 2, -20, 34, 113, 
    23, 0.0, 15, 5, 1, -43, 5, -4, -43, -3, -47, -35, 22, 5, 1, -10, 53, 
    15, 0.0, 2, -7, -7, -41, -26, -12, -8, -4, -25, -9, 10, -12, -4, -14, 32, 68, 
    5, 0.0, 18, -63, -47, -3, -68, -44, 69, -44, 36, 31, -51, -42, -37, -49, -28, 0, 74, 
    -74, 0.0, -93, -105, -108, 63, -80, -13, -27, -71, -11, -46, -79, -76, -92, -58, -62, -87, -61, 289, 
    0, 0.0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    -45, 0.0, -6, -73, -51, 104, -79, 48, -24, -49, -4, -20, -29, -83, -48, -39,-31, -40, -32, 81, 0, 162, 
    0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0
  },

  {0.0, 0.0},  

  {300.0, 11.0},  

  0.0,
      
};

static score_m vla_200 =
{
  "vla",
  
  200,                           /* PAM distance */    

//  LN10/10,                      /* Beta = (ln10)/10  */
  1,                      /* Beta = (ln10)/10  */

  "ABCDEFGHIKLMNPQRSTVWXYZ",    /* amino acid order */ 
  
  {
    0.811, 
    0.0, 0.0, 
    0.271, 0.0, 2.760, 
    -0.190, 0.0, -0.920, 1.432, 
    -0.119, 0.0, -0.860, 0.727, 1.126, 
    -0.588, 0.0, -0.696, -1.379, -1.095, 1.806, 
    0.094, 0.0, -0.422, -0.095, -0.259, -1.199, 1.728, 
    -0.333, 0.0, -0.399, 0.016, -0.056, 0.022, -0.443, 1.801, 
    -0.213, 0.0, -0.029, -1.113, -0.840, 0.104, -1.258, -0.678, 1.111, 
    -0.208, 0.0, -0.768, 0.033, 0.307, -0.992, -0.388, 0.038, -0.707, 1.004, 
    -0.375, 0.0, -0.586, -1.162, -0.786, 0.409, -1.186, -0.496, 0.636, -0.640, 1.127, 
    -0.234, 0.0, -0.103, -0.856, -0.627, 0.345, -0.974, -0.585, 0.560, -0.382, 0.763, 1.396, 
    -0.142, 0.0, -0.458, 0.593, 0.146, -0.847, 0.010, 0.252, -0.815, 0.146, -0.832, -0.587, 1.212, 
    -0.007, 0.0, -0.607, -0.207, -0.188, -0.875, -0.497, -0.325, -0.811, -0.187, -0.623, -0.725, -0.362, 1.981, 
    -0.143, 0.0, -0.736, 0.183, 0.511, -0.732, -0.416, 0.347, -0.631, 0.414, -0.466, -0.264, 0.127, -0.102, 1.054, 
    -0.317, 0.0, -0.572, -0.451, -0.168, -0.868, -0.452, 0.220, -0.731, 0.848, -0.634, -0.404, -0.014, -0.290, 0.406, 1.456, 
    0.292, 0.0, 0.170, 0.030, -0.013, -0.564, 0.034, -0.069, -0.587, -0.063, -0.626, -0.471, 0.273, 0.037, -0.004, -0.167, 0.760, 
    0.185, 0.0, -0.009, -0.126, -0.126, -0.559, -0.379, -0.180, -0.126, -0.075, -0.358, -0.131, 0.107, -0.186, -0.071, -0.215, 0.425, 0.949, 
    0.058, 0.0, 0.196, -0.831, -0.615, -0.092, -0.898, -0.601, 0.864, -0.589, 0.408, 0.356, -0.681, -0.566, -0.493, -0.665, -0.389, -0.013, 0.977, 
    -0.965, 0.0, -1.238, -1.335, -1.406, 0.706, -1.021, -0.201, -0.378, -0.918, -0.188, -0.649, -1.027, -0.971, -1.206, -0.743, -0.796, -1.154, -0.834, 3.447, 
    0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 
    -0.609, 0.0, -0.091, -0.969, -0.653, 1.237, -1.031, 0.596, -0.356, -0.643, -0.107, -0.328, -0.381, -1.105, -0.654, -0.518, -0.404, -0.546, -0.449, 0.922, 0.0, 2.016, 
    0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0
  },

  {0.0, 0.0},   /* gap open und extend penalties for an all positive matrix */

  {2.9, 0.25},  /* gap open und extend penalties for a +/- matrix */

  0.0,
      
};


static score_m n_blosum_65 =
{
  "n_blosum_65",
  
  65,                           /* PAM distance */    

  1,                      /* Beta = 1 */
//  LN10/10,                      /* Beta = 1 */

  "ABCDEFGHIKLMNPQRSTVWXYZ",    /* amino acid order */ 
/*  
  {
    4, 
    -1, 4, 
    -1, -3, 12, 
    -1, 5, -3, 7, 
    -1, 1, -3, 2, 5, 
    -2, -3, -1, -3, -3, 7, 
    0, -1, -3, -1, -2, -3, 7, 
    -2, 0, -2, -1, -1, -2, -2, 10, 
    -1, -3, -2, -3, -3, 0, -4, -3, 5, 
    -1, 0, -3, 0, 1, -2, -2, 0, -2, 5, 
    -1, -3, -2, -3, -2, 1, -4, -3, 2, -2, 5, 
    0, -2, -2, -3, -2, 1, -2, -2, 2, -1, 2, 6, 
    -1, 4, -2, 2, 0, -2, 0, 1, -2, 0, -2, -2, 6, 
    -1, -1, -3, -1, 0, -2, -1, -2, -2, -1, -2, -2, -1, 8, 
    -1, 1, -3, 1, 2, -2, -1, 0, -2, 1, -2, 0, 1, -1, 5, 
    -1, 0, -3, -1, 1, -2, -2, 0, -2, 2, -2, -1, 0, -1, 1, 6, 
    1, 0, -2, 0, 0, -2, 0, -1, -2, 0, -2, -1, 1, 0, 0, -1, 4, 
    0, 0, -2, -1, -1, -2, -2, -1, -1, 0, -1, -1, 0, -1, 0, -1, 2, 4, 
    0, -2, -2, -3, -2, 0, -3, -2, 3, -2, 1, 1, -2, -2, -2, -2, -1, 0, 4, 
    -2, -2, -2, -2, -2, 2, -2, -1, -1, -2, 0, 0, -2, -2, -1, -1, -2, -1, -1, 12, 
    0, 0, -2, -1, -1, -1, -1, -1, -1, -1, -1, 0, 0, -1, 0, -1, 0, 0, -1, -1, -1, 
    -2, -2, -2, -2, -2, 3, -3, 1, -1, -2, -1, -1, -1, -2, -1, -1, -2, -1, -1, 3, -1, 8, 
    -1, 0, -3, 2, 4, -2, -2, 0, -2, 1, -2, -1, 0, 0, 3, 1, 0, 0, -2, -2, 0, -2, 4, 
  },
*/
  
  {
1,
0,1,
0,0,1,
0,0,0,1,
0,0,0,0,1,
0,0,0,0,0,1,
0,0,0,0,0,0,1,
0,0,0,0,0,0,0,1,
0,0,0,0,0,0,0,0,1,
0,0,0,0,0,0,0,0,0,1,
0,0,0,0,0,0,0,0,0,0,1,
0,0,0,0,0,0,0,0,0,0,0,1,
0,0,0,0,0,0,0,0,0,0,0,0,1,
0,0,0,0,0,0,0,0,0,0,0,0,0,1,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
  },

  {0.0, 0.0},   /* gap open und extend penalties for an all positive matrix */

//  {90.0, 10.0},  /* gap open und extend penalties for a +/- matrix */
//  {12.0, 1.0},  /* gap open und extend penalties for a +/- matrix */
  {3, 1.0},  /* gap open und extend penalties for a +/- matrix */

  0.0,
      
};


/*----------------------------------------------------------------------------------------------------------------------------------------*/
/* this fuction creates a score_m array XX-series, which contains pointers to all matrices of the XX matrix series */
score_m **init_matseries()
{
  score_m **matx;
    
  /* the pam and blosum series have each 4 members:
     pam_series [pam]: pam_20, pam_60, pam_120, pam_350; 
     blosum_series [blo]: blosum_30, blosum_50, blosum_62, blosum_80;

     the gonnet_series, which is the default series, has 7 members:
     gonnet_series [gon]: gonnet_40, gonnet_80, gonnet_120, gonnet_160,
                          gonnet_250, gonnet_300, gonnet_350;
  */
  
 
  if(strncasecmp(MAT_SER,"gon",3) == 0)
    {
      matx =(score_m**) calloc((8),sizeof(score_m*));

      matx[0]=&gonnet_40;
      matx[1]=&gonnet_80;
      matx[2]=&gonnet_120;
      matx[3]=&gonnet_160;
      matx[4]=&gonnet_200;
      matx[5]=&gonnet_250;
      matx[6]=&gonnet_300;
      matx[7]=&gonnet_350;
      

      if(plus() != 0)
	{
	  fprintf(stderr,"init_matseries: gon_p matrices are not available");
	  usage(0);
	  exit(20);
	}
    }
  else if(strncasecmp(MAT_SER,"blo",3) == 0)
    {
      matx =(score_m**) calloc((4),sizeof(score_m*));

      matx[0]=&blosum_30;
      matx[1]=&blosum_50;
      matx[2]=&blosum_62;
      matx[3]=&blosum_80;
    }
  else if(strncasecmp(MAT_SER,"pam",3) == 0)
    {
      matx =(score_m**) calloc((5),sizeof(score_m*));

      matx[0]=&pam_20;
      matx[1]=&pam_60;
      matx[2]=&pam_120;
      matx[3]=&pam_160;
      matx[4]=&pam_350;
    }
  else if(strncasecmp(MAT_SER,"vtm",3) == 0)
    {
      matx =(score_m**) calloc((3),sizeof(score_m*));

      matx[0]=&vtml_160;
      matx[1]=&vtml_190;
      matx[2]=&vtml_240;
    }
  else if(strncasecmp(MAT_SER,"n_b",3) == 0)
    {
      matx =(score_m**) calloc((1),sizeof(score_m*));

      matx[0]=&n_blosum_65;
    }
  else if(strncasecmp(MAT_SER,"vla",3) == 0)
    {
      matx =(score_m**) calloc((1),sizeof(score_m*));

      matx[0]=&vla_200;
    }
  else
  /*  if((strncasecmp(MAT_SER,"gon",3)!= 0) && (strncasecmp(MAT_SER,"blo",3)!= 0) && (strncasecmp(MAT_SER,"pam",3)!= 0)) */
    {
      fprintf(stderr,"init_matseries: error in scoring matrix selection, no score matrix selected");
       usage(0);
       exit(21);
    }
  return(matx);
  
}

/******* OLD ***********



static score_m vtml_240 =
{
  "vtml_240",
  
  240,                            

  1,     

  "ABCDEFGHIKLMNPQRSTVWXYZ", 
  
  {
    3, 
    -1, 4, 
    1, -3, 11, 
    -1, 4, -3, 6, 
    0, 2, -3, 3, 4, 
    -2, -4, -2, -5, -4, 7, 
    0, 0, -2, 0, -1, -5, 7, 
    -1, 1, -1, 0, 0, 0, -2, 7, 
    -1, -4, 0, -4, -3, 1, -5, -3, 4, 
    -1, 0, -3, 0, 1, -4, -1, 0, -3, 4, 
    -1, -4, -2, -4, -3, 2, -5, -2, 3, -2, 4, 
    -1, -3, 0, -3, -2, 1, -4, -2, 2, -1, 3, 5, 
    0, 3, -2, 2, 1, -3, 0, 1, -3, 1, -3, -2, 4, 
    0, -1, -2, -1, -1, -3, -2, -1, -3, -1, -2, -3, -1, 8, 
    0, 1, -3, 1, 2, -3, -1, 1, -2, 2, -2, -1, 1, 0, 4, 
    -1, -1, -2, -1, 0, -3, -2, 1, -3, 3, -2, -2, 0, -1, 2, 6, 
    1, 1, 1, 0, 0, -2, 0, 0, -2, 0, -2, -2, 1, 0, 0, -1, 3, 
    1, 0, 0, 0, 0, -2, -1, -1, 0, 0, -1, 0, 0, -1, 0, -1, 2, 3, 
    0, -3, 1, -3, -2, 0, -3, -2, 3, -2, 2, 2, -3, -2, -2, -2, -1, 0, 4, 
    -4, -5, -5, -5, -5, 3, -4, -1, -1, -4, -1, -2, -4, -4, -5, -3, -3, -4, -3, 14, 
    0, -1, -1, -1, -1, -1, -2, 0, -1, -1, -1, -1, -1, -1, 0, -1, 0, 0, -1, -2, -1, 
    -2, -3, 0, -4, -3, 5, -4, 2, -1, -2, 0, -1, -1, -4, -2, -2, -2, -2, -2, 4, -1, 8, 
    0, 1, -3, 2, 3, -3, -1, 1, -3, 1, -2, -2, 1, 0, 3, 1, 0, 0, -2, -5, -1, -2, 3
  },

  {0.0, 0.0},

  {12.0, 1.0}, 

  0.0,
      
};


**************/
